'Print Preview Include by Gary Beene  ver 5.12     16 Dec 2013
'This code is released to public domain. There are no restrictions on its use.

'Features:
'Visit the home page for feature information:  http://www.garybeene.com/sw/gbprintpreview.htm

#Include "cgdiplus.inc"

#Resource Icon ppprintall, "images\ppprintall.ico"
#Resource Icon ppprint, "images\ppprint.ico"
#Resource Icon ppleft, "images\ppprevious.ico"
#Resource Icon ppright, "images\ppnext.ico"
#Resource Icon pporientation, "images\ppportrait.ico"
#Resource Icon ppsettings, "images\ppactions.ico"
#Resource Icon ppgrid, "images\ppmargin.ico"
#Resource Icon ppprintpage, "images\ppprintpage.ico"
#Resource Icon ppprintrange, "images\ppprintrange.ico"
#Resource Icon ppzoom, "images\ppzoom.ico"
#Resource Icon ppmargins, "images\ppmargin.ico"
#Resource Icon ppheader, "images\ppheader.ico"
#Resource Icon ppfooter, "images\ppfooter.ico"
#Resource Icon ppcancel, "images\ppcancel.ico"
#Resource Icon ppwordwrap, "images\ppwordwrap.ico"
#Resource Icon pphelp, "images\pphelp.ico"
#Resource Icon pphome, "images\pphome.ico"
#Resource Icon ppend, "images\ppend.ico"
#Resource Icon ppfont, "images\ppfont.ico"

'version
$PPVer = "5.12"

'Print Preview Equates =====================================
Enum Controls Singular
   IDT_PPSelect      = 5000
   IDT_PPSettings
   IDT_PPPrior
   IDT_PPNext
   IDT_PPAll
   IDT_PPPage
   IDT_PPRange
   IDT_PPZoom
   IDT_PPOrientation
   IDT_PPShowMargins
   IDT_PPWordWrap
   IDT_PPHeader
   IDT_PPFooter
   IDT_PPBlankA
   IDT_PPBlankB
   IDT_PPBlankC
   IDT_PPHome
   IDT_PPEnd
   IDT_PPHelp
   IDT_PPClose

   IDC_PPToolbar
   IDC_PPGraphic
   IDC_PPPageLabel
   IDC_PPMinPage
   IDC_PPMaxPage
   IDC_PPRangeLabel

   IDC_PPSCustomFFText
   IDC_PPSExtensions
   IDC_PPSBGImageName
   IDC_PPSFileName
   IDC_PPSMT
   IDC_PPSML
   IDC_PPSMR
   IDC_PPSMB
   IDC_PPSHeaderHeight
   IDC_PPSHeaderCW
   IDC_PPSHeaderCH
   IDC_PPSHeaderLeft
   IDC_PPSHeaderCenter
   IDC_PPSHeaderRight
   IDC_PPSFooterHeight
   IDC_PPSFooterCW
   IDC_PPSFooterCH
   IDC_PPSFooterLeft
   IDC_PPSFooterCenter
   IDC_PPSFooterRight


   IDC_PPSFrameText
   IDC_PPSFrameHeader
   IDC_PPSFrameFooter
   IDC_PPSOrientation
   IDC_PPSTextColor
   IDC_PPSTextColorL
   IDC_PPSBGColor
   IDC_PPSBGColorL
   IDC_PPSShowBGImage
   IDC_PPSGrayScaleBG
   IDC_PPSLightenBG
   IDC_PPSWordWrap
   IDC_PPSZoom
   IDC_PPSAutoClose
   IDC_PPSLineNumbers
   IDC_PPSMarginOutlines
   IDC_PPSCustomFF
   IDC_PPSLabelExtensions
   IDC_PPSFont
   IDC_PPSSampleFont
   IDC_PPSSelectBGImage
   IDC_PPSSelectFileName
   IDC_PPSMarginL
   IDC_PPSMTL
   IDC_PPSMLL
   IDC_PPSMRL
   IDC_PPSMBL

   IDC_PPSShowHeader
   IDC_PPSGrayScaleH
   IDC_PPSLightenH
   IDC_PPSNaturalH
   IDC_PPSHeaderHeightL
   IDC_PPSHeaderImage
   IDC_PPSHeaderBorder
   IDC_PPSFontH
   IDC_PPSSampleFontH
   IDC_PPSSelectImageH
   IDC_PPSImageNameH
   IDC_PPSContainerHL
   IDC_PPSTitlesHL

   IDC_PPSShowFooter
   IDC_PPSGrayScaleF
   IDC_PPSLightenF
   IDC_PPSNaturalF
   IDC_PPSFooterHeightL
   IDC_PPSFooterImage
   IDC_PPSFooterBorder
   IDC_PPS_FooterBorder
   IDC_PPSFontF
   IDC_PPSSampleFontF
   IDC_PPSSelectImageF
   IDC_PPSImageNameF
   IDC_PPSContainerFL
   IDC_PPSTitlesFL

   IDC_PPSSaveAndExit
   IDC_PPSApply
   IDC_PPSCancel

   IDM_PPGrayScale

   IDM_PPTest
   IDM_PPHelp
   IDM_PPProperties
   IDM_PPZoomPage
   IDM_PPZoomDualPage
   IDM_PPZoomWidth
   IDM_PPZoom25
   IDM_PPZoom50
   IDM_PPZoom75
   IDM_PPZoom100
   IDM_PPZoom200
   IDM_PPZoom400
   IDM_PPSep

   IDM_PPHome
   IDM_PPEnd
   IDM_PPNext
   IDM_PPPrior
   IDM_PPCopyPage
   IDM_PPSavePageImageAsBMP
   IDM_PPSavePageImageAsJPG
   IDM_PPCopyText
   IDM_PPCopyDocText
   IDM_PPFormFeed
   IDM_PPFormFeed12
   IDM_PPImageBorders
   IDM_PPImageTrueSize
   IDM_PPUnix


   IDM_PPSortA
   IDM_PPSortD
   IDM_PPSortN
   IDM_PPJustify
   IDM_PPCut
   IDM_PPCopy
   IDM_PPPaste
   IDM_PPDelete
   IDM_PPSaveAs
   IDM_PPOpenFile
   IDM_PPOpenSavedAsFile
   IDM_PPSampleText
   IDM_PPLineNumbers

End Enum

' orientation
%PPOrientation_Landscape  = 0
%PPOrientation_Portrait   = 1

' ZOOM Constants =  1 based index of selected item in combobix
%PPZoom_Page  =  1
%PPZoom_DualPage  =  2
%PPZoom_Width =  3
%PPZoom_25    =  4
%PPZoom_50    =  5
%PPZoom_75    =  6
%PPZoom_100   =  7
%PPZoom_200   =  8
%PPZoom_400   =  9

'Other equates
%PPToolbar_Height = 60

Type PPCustomColors
   c(15) As Long
End Type

Type PPPrintPreviewGlobal
   'various handles
   hDlg As Dword                           'handle to gbPrinterPreview dialog
   hSetupDlg As Dword                      'handle to setup dialog
   hPopupZoom As Dword                     'handle to dropdown context menu (IDT_PPZoom button)
   hPopupText As Dword                     'handle to Min/Max page text boxes
   hPopupGraphic As Dword                  'handle to context menu (graphic control)
   hControlFont As Dword                   'handle to Font used by controls
   hControlFontB As Dword                  'handle to Bold Font used by controls
   hFontText As Dword                      'handle to Font of main text
   hFontHeader As Dword                    'handle to Font of header
   hFontFooter As Dword                    'handle to Font of footer
   hFontTextSF As Dword                    'handle to Font of main text - adusted by Scale Factor
   hFontHeaderSF As Dword                  'handle to Font of header text - adusted by Scale Factor
   hFontFooterSF As Dword                  'handle to Font of footer text - adusted by Scale Factor
   hImageFooter As Dword                   'handle to Footer memory bitmap
   hImageHeader As Dword                   'handle to Header memory bitmap
   hImageBackGround As Dword               'handle to Background memory bitmap
   hHook As Dword                          'handle to Hook
   hFakeBmp As Dword                       'handle to fake image

   'misc variables
   OldProc As Dword                        'Subclass variable (min/max page textboxes)
   ImageList As Dword                      'toolbar imagelist handle
   ZoomText As String * 47                 'text for dropdown combo
   PrinterSelect As Long                   'printer selection in work?
   SavedAsFile As StringZ * %Max_Path      'file name where main text came from
   SampleText As Long                      '0=std sample  1=sample with page break 2=list

   'Page Printing information
   CurrentPage As Long                     'page currently selected for printing
   LinesPerPage As Long                    '# of line to be printed on a page
   MaxPages As Long                        'total page count at current settings
   MaxTextWidthSF100 As Long               'available width in which to print text
   PrintTime As StringZ * 11               'time at which printing is initiated. same for all pages
   PrintDate As StringZ * 11               'time at which printing is initiated. same for all pages

   'Location of printable text
   TextX0 As Long                          'upper/left
   TextY0 As Long                          'upper/left
   TextX1 As Long                          'lower/right
   TextY1 As Long                          'lower/right
   TextLineH As Long                       'height of a single line

   'Screen Properties
   ScreenPPIx As Long                      'screen ppi in x direction
   ScreenPPIy As Long                      'screen ppi in y direction

   'Printer properties
   PaperW As Long                          'paper width (includes margins, excludes dead zones)
   PaperH As Long                          'paper height (includes margins, excludes dead zones)
   DeadZoneBottom As Long                  'printer bottom dead zone
   DeadZoneLeft As Long                    'printer left dead zone
   DeadZoneRight As Long                   'printer right dead zone
   DeadZoneTop As Long                     'printer top dead zone
   FooterHeight As Single                  'height allocated to Footer
   HeaderHeight As Single                  'height allocated to Header
   PrinterPPIx As Long                     'printer ppi in x direction
   PrinterPPIy As Long                     'printer ppi in y direction

   'Footer/Header Images
   FooterImageW As Long                    'footer image width
   FooterImageH As Long                    'footer image height
   HeaderImageH As Long                    'header image height
   HeaderImageW As Long                    'header image width
   BGImageH As Long                        'background image height
   BGImageW As Long                        'background image width

   'Graphic Display setting
   PreviewX0 As Long
   PreviewY0 As Long
   PreviewW As Long
   PreviewH As Long
   VirtualW As Long
   VirtualH As Long
End Type

Type PPPrintPreviewData
    'Initial Dialog size/location
    hParent As Dword                       'parent dialog handle
    DialogX As Long                        'initial dialog x
    DialogY As Long                        'initial dialog y
    DialogH As Long                        'initial dialog h
    DialogW As Long                        'initial dialog w

    'Misc Settings
    FileName As StringZ * %Max_Path        'file name where main text came from
    FileListName As StringZ * %Max_Path    'file name containing a list of files to print
    TextExtensions As StringZ * %Max_Path  'extensions for text file

    'Quiet Printing settings
    QuietPrint As Long                     'print without showing    1=all page  2=range QMinPage to QMaxPage
    QMaxPage As Long                       'ending page for quiet print
    QMinPage As Long                       'starting page for quiet print

    'Printer Settings
    PrinterName As StringZ * %Max_Path     'printer name (default = "")
    Orientation As Long                    'initial orientation 0=landscape 1=portrait
    PaperSizeW As Single                   'full paper width - inches
    PaperSizeH As Single                   'full paper height - inches
    MarginTop As Single                    'top margin - inches
    MarginLeft As Single                   'left margin - inches
    MarginBottom As Single                 'bottom margin - inches
    MarginRight As Single                  'right margin - inches
    AutoClose As Long                      'autoclose on print  1=yes 0=no

    'Main Body Settings
    ShowMargins As Long                    'show margins  1=yes 0=no
    WordWrap As Long                       'wordwrap  1=yes 0=no
    ZoomFactor As Long                     'zoom factor 1=fit_inside  2=fit_width  3=25% 4=50% 5=75% 6=100% 7=200% 8=400$
    TextColor As Long                      'text color
    FontName As StringZ * %Max_Path        'font name (main text)
    FontPoints As Single                   'font size (points) (main text)
    FontPointsSF As Single                 'font size (points) (main text) at SF
    FontStyle As Long                      'font style  0=normal 1=bold (main text)
    LineNumbers As Long                    '1=yes 0=no
    CustomFF As Long                       '1=yes 0=no  use custom form feed. Chr$(12) is default
    CustomFFText As StringZ *20            'string that indicates a page break
    SortMethod As Long                     '0=none 1=Ascending 2=Descending
    Justify As Long                        '0=no 1=yes
    Unix As Long                           '1=Unix 0=PC

    'Background settings
    ShowBGImage As Long                    '1=yes 0=no
    GrayScaleBG As Long                    '1=yes 0=no
    LightenBG As Long                      '1=yes 0=no
    NaturalBG As Long                      '1=yes 0=no
    BGImageName As StringZ * %Max_Path     'background image
    BGColor As Long                        'background color

    'Header settings
    ShowHeader As Long                         'show header  1=yes 0=no
    ShowHeaderImage As Long                    '1=yes 0=no
    GrayScaleH As Long                         '1=yes 0=no
    LightenH As Long                           '1=yes 0=no
    HeaderImageBorder As Long                  '1=yes 0=no black border around image (uses up image area)
    HeaderImageName As StringZ * %Max_Path     'header image file name, *.bmp
    HeaderHeight As Single                     'header height - inches
    HeaderImageContW As Single                 'header image container width - inches
    HeaderImageContH As Single                 'header image container height - inches
    HeaderNatural As Long                      'display header image as natural size
    TopLeftText As StringZ * %Max_Path         'header string - top left
    TopCenterText As StringZ * %Max_Path       'header string - top center
    TopRightText As StringZ * %Max_Path        'header string - top right
    FontNameH As StringZ * %Max_Path           'font name (header/footer)
    FontPointsH As Single                      'font size (header/footer) at SF
    FontPointsHSF As Single                      'font size (header/footer)
    FontStyleH As Long                         'font style (header/footer)  0=normal 1=bold

    'Footer settings
    ShowFooter As Long                         'show footer  1=yes 0=no
    ShowFooterImage As Long                    '1=yes 0=no
    GrayScaleF As Long                         '1=yes 0=no
    LightenF As Long                           '1=yes 0=no
    FooterImageBorder As Long                  '1=yes 0=no black border around image (uses up image area)
    FooterImageName As StringZ * %Max_Path     'footer image file name, *.bmp
    FooterHeight As Single                     'footer height - inches
    FooterImageContW As Single                 'footer image container width - inches
    FooterImageContH As Single                 'footer image container height - inches
    FooterNatural As Long                      'display footer image as natural size
    BottomLeftText As StringZ * %Max_Path      'footer string - bottom left
    BottomCenterText As StringZ * %Max_Path    'footer string - bottom center
    BottomRightText As StringZ * %Max_Path     'footer string - bottom right
    FontNameF As StringZ * %Max_Path           'font name (header/footer)
    FontPointsF As Single                      'font size (header/footer)
    FontPointsFSF As Single                    'font size (header/footer) at SF
    FontStyleF As Long                         'font style (header/footer)  0=normal 1=bold

End Type

'PrintPreview Global variables =================================================================
Global PPPrintArray() As String, PPGlobalText As String
Global tempPPD, PPD As PPPrintPreviewData, tempPPG, PPG As PPPrintPreviewGlobal

Sub gbPrintPreview(PPData As PPPrintPreviewData, PPText As String)
   PPD = PPData
   PPGlobalText = PPText
   Dialog New Pixels, PPD.hParent, "gbPrintPreview", PPD.DialogX, PPD.DialogY, PPD.DialogW, PPD.DialogH, %WS_OverlappedWindow Or %WS_ClipChildren To PPG.hDlg
   Dialog Set Icon PPG.hDlg, "pplogo"
   Control Add Label, PPG.hDlg, %IDC_PPPageLabel, "1", 175,5,25,25, %WS_Border Or %SS_Center Or %SS_CenterImage Or %SS_Notify
   Control Add TextBox, PPG.hDlg, %IDC_PPMinPage, "1", 387,5,25,25
   Control Add TextBox, PPG.hDlg, %IDC_PPMaxPage, "1", 425,5,25,25
   PPCreateToolbar
   PPG.CurrentPage = 1             'always start on page 1 of document
   PPLoadImagesToMemoryBitmaps     'load header and footer image files to memory bitmaps
   PPCreateGraphic                 'create Graphic control
   PPAttachToSpecifiedPrinter      'attach to specified printer
   PPSetPrinterProperties          'initialize properties and display content to be printed
   PPBuildFonts                    'create required fonts
   PPBuildFontsSF                  'create SF Text font
   If PPD.ShowHeader Then PPG.HeaderHeight = PPD.HeaderHeight  Else PPG.HeaderHeight = 0
   If PPD.ShowFooter Then PPG.FooterHeight = PPD.FooterHeight  Else PPG.FooterHeight = 0
   PPSetLinesPerPageAtSF100
   PPBuildPrintArray               'get text ready for printing
   PPPrintToGraphic                'need early so can use PPBuildSFFont
   'quiet printing, if required, then exit
   If PPD.QuietPrint = 1 Then PPSendToPrinter 0, PPD.QMinPage, PPD.QMaxPage : Dialog End PPG.hDlg : Exit Sub   'all
   If PPD.QuietPrint = 2 Then PPSendToPrinter 0, PPD.QMinPage, PPD.QMaxPage : Dialog End PPG.hDlg : Exit Sub   'range
   'show gbPrintPreview dialog
   Dialog Show Modal PPG.hDlg Call PPPreviewProc
   PPData = PPD                          'send all UDT data back to the calling application
   PPText = Join$(PPPrintArray(), $CrLf) 'might change if user has selected a new file, or sorted, or ...
ImageList Kill PPG.ImageList

End Sub

CallBack Function PPPreviewProc() As Long
   Local P As TooltipText Ptr, nmtb As TBNotify Ptr, rc As Rect, x,y,iResult,ViewX,ViewY As Long, temp$
   Static ddx, ddy As Long
   'this is the Callback function for the Print Preview dialog.
   Select Case Cb.Msg
      Case %WM_InitDialog
'         If PPD.ShowHeader Then PPG.HeaderHeight = PPD.HeaderHeight  Else PPG.HeaderHeight = 0
'         If PPD.ShowFooter Then PPG.FooterHeight = PPD.FooterHeight  Else PPG.FooterHeight = 0
         PPRebuildToolbar
         PPSubClassToolbarTextBoxes
         PPBuildAcceleratorTable
         PPSetMenusAndToolbarButtons
         Font New "Tahoma",8,0 To PPG.hControlFont
         Font New "Tahoma",10,1 To PPG.hControlFontB
         Control Set Font PPG.hDlg, %IDC_PPPageLabel, PPG.hControlFont
         Control Set Font PPG.hDlg, %IDC_PPMinPage, PPG.hControlFont
         Control Set Font PPG.hDlg, %IDC_PPRangeLabel, PPG.hControlFont
         Control Set Font PPG.hDlg, %IDC_PPMaxPage, PPG.hControlFont
         Control Set Font PPG.hDlg, %IDC_PPToolbar, PPG.hControlFont
         Control Set Focus PPG.hDlg, %IDC_PPGraphic
      Case %WM_Size
         PPResizeWindow
         PPBuildFontsSF
         PPPrintToGraphic
'      Case %WM_SetCursor
'         GetCursorPos pt
'         ScreenToClient hDlg, pt
'         If ChildWindowFromPoint(PPG.hDlg,pt) = GetDlgItem(PPG.hDlg,%IDC_PPGraphic) Then '<--- Approach #2
'            Control Set Focus PPG.hDlg, %IDC_PPGraphic
'         End If
      Case %WM_MouseMove
         If Cb.WParam And %MK_LBUTTON Then
            ViewX = Max(0,Graphic(View.X) + ddx - Lo(Word,Cb.LParam))
            ViewY = Max(0,Graphic(View.Y) + ddy - Hi(Word,Cb.LParam))
            ViewX = Min(ViewX, Graphic(Canvas.X))
            ViewY = Min(ViewY, Graphic(Canvas.Y))
            Graphic Set View ViewX, ViewY
            ddx = Lo(Word, Cb.LParam)
            ddy = Hi(Word, Cb.LParam)
         End If
      Case %WM_LButtonDown
         ddx = Lo(Word, Cb.LParam)
         ddy = Hi(Word, Cb.LParam)
      Case %WM_Notify
         nmtb = Cb.LParam
         Select Case @nmtb.hdr.Code
            Case %TBN_DROPDOWN
               Select Case @nmtb.iItem
                  Case %IDT_PPZoom
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (PPG.hPopUpZoom, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
               End Select
         End Select
         Select Case Cb.NmId
            Case %IDT_PPSelect To %IDT_PPClose
                Select Case Cb.NmCode
                   Case %TTN_GetDispInfo
                      P = Cb.LParam
                      @P.@lpszText = PPSetToolTips(Cb.NmId)
                End Select
         End Select
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_PPGraphic
               If Cb.CtlMsg = %STN_Clicked Then Control Set Focus PPG.hDlg, %IDC_PPGraphic
            Case %IDM_PPTest      'F9
                XPrint Attach PPD.PrinterName
                XPrint "Printer connection is working!"
                XPrint Close
                XPrint Attach PPD.PrinterName

            Case %IDM_PPHelp : MsgBox "gbPrintPreview   v" + $PPVer, %MB_Ok + %MB_IconInformation, "gbPrintPreview"
            Case %IDT_PPSelect
               If PPG.PrinterSelect = 0 Then
                  PPG.PrinterSelect = 1
                  XPrint Attach Choose
                  If Len(XPrint$)=0 Then XPrint Attach PPD.PrinterName
                  XPrint Set Font PPG.hFontText   '<--- used to get lines per page
                  PPSetPrinterProperties
                  XPrint Get Orientation To iResult  '<--- get user selection of Printer orientation
                  Select Case iResult
                     Case 0,1 : PPD.Orientation = 1  'Portrait
                     Case 2   : PPD.Orientation = 0  'Landscape
                  End Select
                  PPSetMenusAndToolbarButtons  '<--- updates Toolbar with orientation selection
                  PPD.PrinterName = XPrint$  '<--- get user selection of Printer Name
                  PPResizeWindow
                  MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1
                  PPPrintToGraphic
                  PPG.PrinterSelect = 0
                  Control Set Focus PPG.hDlg, %IDC_PPMinPage
               End If
            Case %IDT_PPSettings
               PPPageSetupDialog
               Control Set Focus PPG.hDlg, %IDC_PPGraphic
            Case %IDM_PPProperties : PPDisplayPrintProperties
            Case %IDT_PPAll        : PPSendToPrinter(0,0,0) : If PPD.AutoClose Then Dialog End PPG.hDlg
            Case %IDT_PPPage       : PPSendToPrinter(1,0,0) : If PPD.AutoClose Then Dialog End PPG.hDlg
            Case %IDT_PPRange      : PPSendToPrinter(2,0,0) : If PPD.AutoClose Then Dialog End PPG.hDlg
            Case %IDT_PPClose      : Dialog End PPG.hDlg
            Case %IDT_PPPrior, %IDM_PPPrior
               If PPG.CurrentPage = 1 Then
                  Beep
               Else
                  Decr PPG.CurrentPage
                  If PPG.CurrentPage < 1 Then PPG.CurrentPage = 1
                  PPPrintToGraphic
               End If

            Case %IDT_PPNext, %IDM_PPNext
               If PPG.CurrentPage = PPG.MaxPages Then
                  Beep
               Else
                  Incr PPG.CurrentPage
                  If PPG.CurrentPage > PPG.MaxPages Then PPG.CurrentPage = PPG.MaxPages
                  PPPrintToGraphic
               End If

            Case %IDT_PPShowMargins
               PPD.ShowMargins = PPD.ShowMargins Xor 1
               PPPrintToGraphic
               PPSetMenusAndToolbarButtons

            Case %IDT_PPWordWrap
               PPD.WordWrap = PPD.WordWrap Xor 1
               MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1
               PPPrintToGraphic
               PPSetMenusAndToolbarButtons

            Case %IDT_PPOrientation
               PPD.Orientation = PPD.Orientation Xor 1
               If PPD.Orientation Then XPrint Set Orientation 1 Else XPrint Set Orientation 2
               PPSetPrinterProperties : PPResizeWindow
               MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1
               PPPrintToGraphic
               PPSetMenusAndToolbarButtons

            Case %IDT_PPHeader
               PPD.ShowHeader = PPD.ShowHeader Xor 1
               If PPD.ShowHeader Then PPG.HeaderHeight = PPD.HeaderHeight  Else PPG.HeaderHeight = 0
               PPSetPrinterProperties : PPResizeWindow : PPPrintToGraphic
               PPSetMenusAndToolbarButtons

            Case %IDT_PPFooter
               PPD.ShowFooter = PPD.ShowFooter Xor 1
               If PPD.ShowFooter Then PPG.FooterHeight = PPD.FooterHeight  Else PPG.FooterHeight = 0
               PPSetPrinterProperties : PPResizeWindow : PPPrintToGraphic
               PPSetMenusAndToolbarButtons

            Case %IDT_PPZoom
               Incr PPD.ZoomFactor
               If PPD.ZoomFactor > %PPZoom_400 Then PPD.ZoomFactor = %PPZoom_Page
               PPReBuildToolbar
               PPResizeWindow
               PPBuildFontsSF
               PPPrintToGraphic
               PPSetMenusAndToolbarButtons

            Case %IDT_PPHelp
               iResult = ShellExecute(PPG.hDlg, "Open", "http://www.garybeene.com/sw/gbprintpreview.htm", $Nul, $Nul, %SW_ShowNormal)


            Case %IDM_PPZoomPage   : PPD.ZoomFactor = %PPZoom_Page  : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons
            Case %IDM_PPZoomDualPage   : PPD.ZoomFactor = %PPZoom_DualPage  : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons
            Case %IDM_PPZoomWidth  : PPD.ZoomFactor = %PPZoom_Width : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons
            Case %IDM_PPZoom25     : PPD.ZoomFactor = %PPZoom_25    : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons
            Case %IDM_PPZoom50     : PPD.ZoomFactor = %PPZoom_50    : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons
            Case %IDM_PPZoom75     : PPD.ZoomFactor = %PPZoom_75    : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons
            Case %IDM_PPZoom100    : PPD.ZoomFactor = %PPZoom_100   : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons
            Case %IDM_PPZoom200    : PPD.ZoomFactor = %PPZoom_200   : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons
            Case %IDM_PPZoom400    : PPD.ZoomFactor = %PPZoom_400   : PPReBuildToolbar : PPResizeWindow : PPBuildFontsSF : PPPrintToGraphic : PPSetMenusAndToolbarButtons

            Case %IDM_PPHome, %IDT_PPHome :  PPG.CurrentPage = 1            : PPPrintToGraphic
            Case %IDM_PPEnd, %IDT_PPEnd  :  PPG.CurrentPage = PPG.MaxPages : PPPrintToGraphic

            Case %IDM_PPCut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_PPCopy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_PPPaste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_PPDelete  : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDM_PPCopyText : PPCopyCurrentPageText
            Case %IDM_PPCopyDocText
               Clipboard Reset
               Clipboard Set Text Join$(PPPrintArray(),$CrLf)
            Case %IDM_PPCopyPage : PPCopyCurrentPageImage
            Case %IDM_PPSavePageImageAsBMP : PPSavePageImageAsBMP
            Case %IDM_PPSavePageImageAsJPG : PPSavePageImageAsJPG

            Case %IDM_PPSortN : PPD.SortMethod = 0 : MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1 : PPPrintToGraphic
            Case %IDM_PPSortA : PPD.SortMethod = 1 : MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1 : PPPrintToGraphic
            Case %IDM_PPSortD : PPD.SortMethod = 2 : MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1 : PPPrintToGraphic

            Case %IDM_PPJustify :
               PPD.Justify Xor=1
               MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1
               PPPrintToGraphic

            Case %IDM_PPSaveAs
               PPSaveAs
            Case %IDM_PPOpenFile
               temp$ = PPSelectFile
               If IsFile(temp$) Then
                  PPD.FileName = temp$
                  Open PPD.FileName For Binary As #1
                  Get$ #1, Lof(1), PPGlobalText
                  Close #1
                  MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1
                  PPPrintToGraphic
               End If
            Case %IDM_PPSampleText
               PPGlobalText = PPSampleText
               PPG.CurrentPage = 1
               MousePtr 11 : PPSetLinesPerPageAtSF100 : PPBuildPrintArray : MousePtr 1
               PPPrintToGraphic

            Case %IDM_PPOpenSavedAsFile
               If IsFile(PPG.SavedAsFile) Then
                  x = ShellExecute(PPG.hDlg, "Open", (PPG.SavedAsFile), $Nul, $Nul, %SW_ShowNormal)
               Else
                  Beep
               End If

            Case %IDM_PPLineNumbers
               PPD.LineNumbers Xor= 1
               PPPrintToGraphic

            Case %IDM_PPGrayScale
               PPD.GrayScaleBG Xor=1 : PPD.GrayScaleF = PPD.GrayScaleBG : PPD.GrayScaleH = PPD.GrayScaleBG
               PPD.LightenBG = PPD.GrayScaleBG : PPD.LightenH = PPD.GrayScaleBG : PPD.LightenF = PPD.GrayScaleBG
               Graphic Attach PPG.hImageBackground, 0 : Graphic Bitmap End
               Graphic Attach PPG.hImageHeader, 0     : Graphic Bitmap End
               Graphic Attach PPG.hImageFooter, 0     : Graphic Bitmap End
               PPLoadImagesToMemoryBitmaps
               PPPrintToGraphic
         End Select

      Case %WM_ContextMenu
         x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
         TrackPopupMenu PPG.hPopUpGraphic, %TPM_LeftAlign, x, y, 0, Cb.Hndl, ByVal 0

      Case %WM_Destroy
         Font End PPG.hFontText
         Font End PPG.hFontHeader
         Font End PPG.hFontFooter
         Font End PPG.hFontTextSF
         Font End PPG.hFontHeaderSF
         Font End PPG.hFontFooterSF
         Font End PPG.hControlFont
         Font End PPG.hControlFontB

         ImageList Kill PPG.ImageList
         XPrint Close
         Dialog Get Loc PPG.hDlg To PPD.DialogX, PPD.DialogY
         Dialog Get Client PPG.hDlg To PPD.DialogW, PPD.DialogH

         'images
         Graphic Attach PPG.hImageHeader, 0 : Graphic Bitmap End
         Graphic Attach PPG.hImageFooter, 0 : Graphic Bitmap End
         Graphic Attach PPG.hImageBackground,0 : Graphic Bitmap End

         SetWindowLong GetDlgItem(PPG.hDlg, %IDC_PPMinPage), %GWL_WNDPROC, PPG.OldProc   'un-subclass
         SetWindowLong GetDlgItem(PPG.hDlg, %IDC_PPMaxPage), %GWL_WNDPROC, PPG.OldProc   'un-subclass
   End Select
End Function

Sub PPCreateToolbar
   Local hPPToolbar As Dword
   ImageList New Icon 24,24,24,20 To PPG.ImageList
   ImageList Add Icon PPG.ImageList, "ppprint"        '1
   ImageList Add Icon PPG.ImageList, "ppsettings"     '2
   ImageList Add Icon PPG.ImageList, "ppright"        '3
   ImageList Add Icon PPG.ImageList, "ppleft"         '4
   ImageList Add Icon PPG.ImageList, "ppprintall"     '5
   ImageList Add Icon PPG.ImageList, "ppprintpage"    '6
   ImageList Add Icon PPG.ImageList, "ppprintrange"   '7
   ImageList Add Icon PPG.ImageList, "ppzoom"         '8
   ImageList Add Icon PPG.ImageList, "pporientation"  '9
   ImageList Add Icon PPG.ImageList, "ppgrid"         '10
   ImageList Add Icon PPG.ImageList, "ppheader"       '11
   ImageList Add Icon PPG.ImageList, "ppfooter"       '12
   ImageList Add Icon PPG.ImageList, "ppcancel"       '13
   ImageList Add Icon PPG.ImageList, "ppwordwrap"     '14
   ImageList Add Icon PPG.ImageList, "pphelp"         '15
   ImageList Add Icon PPG.ImageList, "pphome"         '16
   ImageList Add Icon PPG.ImageList, "ppend"          '17
   ImageList Add Icon PPG.ImageList, "ppdual"         '18

   PPG.ZoomText = "Page DualPage Width 25% 50% 75% 100% 200% 400%"

    Control Add Toolbar, PPG.hDlg, %IDC_PPToolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child Or %WS_ClipSiblings
    Control Handle PPG.hDlg, %IDC_PPToolbar To hPPToolbar
    SendMessage hPPToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList PPG.hDlg, %IDC_PPToolbar, PPG.ImageList, 0             'default imagelist

    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 1, %IDT_PPSelect,  %TbStyle_Button, "Printer"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 2, %IDT_PPSettings,  %TbStyle_Button, "Settings"

    Toolbar Add Separator PPG.hDlg, %IDC_PPToolbar, 5
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 16, %IDT_PPHome,  %TbStyle_Button, "Home"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 4, %IDT_PPPrior,  %TbStyle_Button, "Prior"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 0, %IDT_PPBlankA,  %TbStyle_Button, "Page"
    Toolbar Set State PPG.hDlg, %IDC_PPToolbar,  ByCmd %IDT_PPBlankA,%TBState_Disabled

    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 3, %IDT_PPNext,  %TbStyle_Button, "Next"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 17, %IDT_PPEnd,  %TbStyle_Button, "End"
    Toolbar Add Separator PPG.hDlg, %IDC_PPToolbar, 5

    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 5, %IDT_PPAll,  %TbStyle_Button, "All"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 6, %IDT_PPPage,  %TbStyle_Button, "Page"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 7, %IDT_PPRange,  %TbStyle_Button, "Range"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 0, %IDT_PPBlankB,  %TbStyle_Button, "From     To    "
    Toolbar Set State PPG.hDlg, %IDC_PPToolbar,  ByCmd %IDT_PPBlankB,%TBState_Disabled

    Toolbar Add Separator PPG.hDlg, %IDC_PPToolbar, 5
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 8, %IDT_PPZoom,  %TbStyle_Button Or %TbStyle_DropDown, Parse$(PPG.ZoomText, $Spc, PPD.ZoomFactor)
    Toolbar Add Separator PPG.hDlg, %IDC_PPToolbar, 5

    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 9, %IDT_PPOrientation,  %TbStyle_Button, "Portrait"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 11, %IDT_PPHeader,  %TbStyle_Check, "Header"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 12, %IDT_PPFooter,  %TbStyle_Check, "Footer"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 10, %IDT_PPShowMargins,  %TbStyle_Check, "Margins"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 14, %IDT_PPWordWrap,  %TbStyle_Check, "WordWrap"
    Toolbar Add Separator PPG.hDlg, %IDC_PPToolbar, 5
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 15, %IDT_PPHelp,  %TbStyle_Button, "Help"
    Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 13, %IDT_PPClose,  %TbStyle_Button, "Cancel"

    Menu New PopUp To PPG.hPopupZoom
    Menu Add String, PPG.hPopupZoom, "Page", %IDM_PPZoomPage, %MF_Enabled
    Menu Add String, PPG.hPopupZoom, "Dual Page", %IDM_PPZoomDualPage, %MF_Enabled
    Menu Add String, PPG.hPopupZoom, "Width", %IDM_PPZoomWidth, %MF_Enabled
    Menu Add String, PPG.hPopupZoom, "25%", %IDM_PPZoom25, %MF_Enabled
    Menu Add String, PPG.hPopupZoom, "50%", %IDM_PPZoom50, %MF_Enabled
    Menu Add String, PPG.hPopupZoom, "75%", %IDM_PPZoom75, %MF_Enabled
    Menu Add String, PPG.hPopupZoom, "100%", %IDM_PPZoom100, %MF_Enabled
    Menu Add String, PPG.hPopupZoom, "200%", %IDM_PPZoom200, %MF_Enabled
    Menu Add String, PPG.hPopupZoom, "400%", %IDM_PPZoom400, %MF_Enabled
End Sub

Sub PPSetMenusAndToolbarButtons
   Local i As Long
   'Toolbar Buttons
   Toolbar Set State PPG.hDlg, %IDC_PPToolbar, ByCmd %IDT_PPOrientation, %TBState_Checked * PPD.Orientation Or %TBState_Enabled
   Toolbar Set State PPG.hDlg, %IDC_PPToolbar, ByCmd %IDT_PPFooter, %TBState_Checked * PPD.ShowFooter Or %TBState_Enabled
   Toolbar Set State PPG.hDlg, %IDC_PPToolbar, ByCmd %IDT_PPHeader, %TBState_Checked * PPD.ShowHeader Or %TBState_Enabled
   Toolbar Set State PPG.hDlg, %IDC_PPToolbar, ByCmd %IDT_PPShowMargins, %TBState_Checked * PPD.ShowMargins Or %TBState_Enabled
   Toolbar Set State PPG.hDlg, %IDC_PPToolbar, ByCmd %IDT_PPWordWrap, %TBState_Checked * PPD.WordWrap Or %TBState_Enabled

   'Menus
   For i = %IDM_PPZoomPage To %IDM_PPZoom400
      Menu Set State PPG.hPopupZoom, ByCmd i, %MFS_Enabled
   Next i
   Menu Set State PPG.hPopupZoom, ByCmd %IDM_PPZoomPage+PPD.ZoomFactor-1, %MFS_Enabled Or %MFS_Checked
End Sub

Sub PPBuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(21)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDM_PPHelp             : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F9     : ac(c).cmd   = %IDM_PPTest             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D      : ac(c).cmd   = %IDT_PPSelect           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDT_PPFooter           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G      : ac(c).cmd   = %IDM_PPGrayScale        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H      : ac(c).cmd   = %IDT_PPHeader           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_I      : ac(c).cmd   = %IDM_PPProperties       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_K      : ac(c).cmd   = %IDT_PPPrior            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L      : ac(c).cmd   = %IDM_PPLineNumbers      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M      : ac(c).cmd   = %IDT_PPShowMargins      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N      : ac(c).cmd   = %IDT_PPNext             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P      : ac(c).cmd   = %IDT_PPPage             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R      : ac(c).cmd   = %IDT_PPRange            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S      : ac(c).cmd   = %IDT_PPSettings         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W      : ac(c).cmd   = %IDM_PPZoom100          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_X      : ac(c).cmd   = %IDT_PPClose            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z      : ac(c).cmd   = %IDT_PPZoom             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T      : ac(c).cmd   = %IDM_PPSampleText       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Home   : ac(c).cmd   = %IDM_PPHome             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_End    : ac(c).cmd   = %IDM_PPEnd              : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Left   : ac(c).cmd   = %IDM_PPPrior            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Right  : ac(c).cmd   = %IDM_PPNext             : Incr c
   Accel Attach PPG.hDlg, AC() To hAccelerator
End Sub

Function PPSetToolTips(cID As Long) As String
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_PPSelect           : Function = "Select Printer"
      Case %IDT_PPSettings         : Function = "Settings Dialog"
      Case %IDT_PPHome             : Function = "Display the First Page"
      Case %IDT_PPPrior            : Function = "Show Previous Page"
      Case %IDT_PPNext             : Function = "Show Next Page"
      Case %IDT_PPEnd              : Function = "Display the Last Page"
      Case %IDT_PPAll              : Function = "Print All Pages"
      Case %IDT_PPPage             : Function = "Print Current Page"
      Case %IDT_PPRange            : Function = "Print Page Range"
      Case %IDT_PPZoom             : Function = "Cycle Through All Zoom Settings"
      Case %IDT_PPOrientation      : Function = "Cycle Between Portrait and Landscape Orientation"
      Case %IDT_PPHeader           : Function = "Show Header"
      Case %IDT_PPFooter           : Function = "Show Footer"
      Case %IDT_PPShowMargins      : Function = "Show Page Margins"
      Case %IDT_PPWordWrap         : Function = "Apply WordWrap To Text"
      Case %IDT_PPHelp             : Function = "Open Online Help"
      Case %IDT_PPClose            : Function = "Close Print Preview Dialog"
   End Select
End Function

Sub PPDisplayPrintProperties
   'popup MsgBox with current Print Preview parameters
   Local temp, fmt As String
   Local PPScreenPPIx,  PPScreenPPIy As Long

   'PPScreenPPIx, PPScreenPPIy
   Graphic Get PPI To PPScreenPPIx,PPScreenPPIy
   fmt = "0.00"
'   temp = "PPScreenX " + Str$(PPG.ScreenX)
'   temp = temp + $CrLf + "PPScreenY " + Format$(PPG.ScreenY,fmt$)
'   temp = temp + $CrLf
   temp = temp + $CrLf + "PPMarginLeft " + $Tab + Format$(PPD.MarginLeft)
   temp = temp + $CrLf + "PPMarginRight " +  $Tab + Format$(PPD.MarginRight)
   temp = temp + $CrLf + "PPMarginTop " +  $Tab + Format$(PPD.MarginTop)
   temp = temp + $CrLf + "PPMarginBottom " +  $Tab + Format$(PPD.MarginBottom)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPDeadZoneLeft " +  $Tab + Str$(PPG.DeadZoneLeft)
   temp = temp + $CrLf + "PPDeadZoneTop " +  $Tab + Str$(PPG.DeadZoneTop)
   temp = temp + $CrLf + "PPDeadZoneRight " +  $Tab + Str$(PPG.DeadZoneRight)
   temp = temp + $CrLf + "PPDeadZoneBottom " +  $Tab + Str$(PPG.DeadZoneBottom)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPHeader " +  $Tab + Format$(PPG.HeaderHeight,fmt$)
   temp = temp + $CrLf + "PPFooter " +  $Tab + Format$(PPG.FooterHeight,fmt$)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPHeaderImage " +  $Tab + PPD.HeaderImageName
   temp = temp + $CrLf + "PPFooterImage " +  $Tab + PPD.FooterImageName
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPScreenPPIx " +  $Tab + Str$(PPG.ScreenPPIx)
   temp = temp + $CrLf + "PPScreenPPIy " +  $Tab + Str$(PPG.ScreenPPIy)
   temp = temp + $CrLf + "PPPrinterPPIx " + $Tab + Str$(PPG.PrinterPPIx)
   temp = temp + $CrLf + "PPPrinterPPIy " + $Tab + Str$(PPG.PrinterPPIy)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPMaxPages " +  $Tab + Str$(PPG.MaxPages)
   temp = temp + $CrLf + "PPCurrentPage " +  $Tab + Str$(PPG.CurrentPage)
   temp = temp + $CrLf + "PPOrientation " +  $Tab + Str$(PPD.Orientation)
   temp = temp + $CrLf + "PPLinesPerPage " +  $Tab + Str$(PPG.LinesPerPage)
   temp = temp + $CrLf + "PPMaxTextWidth " +  $Tab + Str$(PPG.MaxTextWidthSF100)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPPreviewX0" +  $Tab + Str$(PPG.PreviewX0)
   temp = temp + $CrLf + "PPPreviewY0" +  $Tab + Str$(PPG.PreviewY0)
   temp = temp + $CrLf + "PPPreviewW" +  $Tab + Str$(PPG.PreviewW)
   temp = temp + $CrLf + "PPPreviewH" +  $Tab + Str$(PPG.PreviewH)
   MsgBox temp, %MB_Ok + %MB_TaskModal, "Print Preview Properties"
End Sub

Sub PPRebuildToolbar
   Toolbar Delete Button PPG.hDlg, %IDC_PPToolbar, ByCmd %IDT_PPZoom
   Toolbar Add Button  PPG.hDlg, %IDC_PPToolbar, 8, %IDT_PPZoom,  %TbStyle_Button Or %TbStyle_DropDown, Parse$(PPG.ZoomText, $Spc, PPD.ZoomFactor) At 15
End Sub

Sub PPAttachToSpecifiedPrinter
   If Len(PPD.PrinterName) Then
      'name provided
      Try
         XPrint Attach PPD.PrinterName
      Catch
         Try
            XPrint Attach Default
         Catch
            MsgBox "Printers not available!", %MB_Ok + %MB_IconExclamation + %MB_TaskModal, "Attaching to Printer"
            Dialog End PPG.hDlg
         End Try
      End Try
   Else
      'user requested default printer
      Try
         XPrint Attach Default
      Catch
            MsgBox "Printer not available!", %MB_Ok + %MB_IconExclamation + %MB_TaskModal, "Attaching to Printer"
            Dialog End PPG.hDlg
      End Try
   End If
   PPD.PrinterName = XPrint$
   If PPD.Orientation Then XPrint Set Orientation 1 Else XPrint Set Orientation 2
End Sub

Sub PPCreateGraphic
   Control Add Graphic, PPG.hDlg, %IDC_PPGraphic, "", 0,%PPToolbar_Height,PPD.DialogW, PPD.DialogH - %PPToolbar_Height, %WS_Border Or %SS_Notify

   Graphic Attach PPG.hDlg, %IDC_PPGraphic, ReDraw
   Graphic Set Overlap
   Graphic Get PPI To PPG.ScreenPPIx,PPG.ScreenPPIy
   Graphic Color PPD.TextColor, %rgb_LightGray : Graphic Clear
   Graphic Clear

   Menu New PopUp To PPG.hPopupGraphic
   Menu Add String, PPG.hPopupGraphic, "Display First Page", %IDM_PPHome, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Display Last Page", %IDM_PPEnd, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "-", %IDM_PPSep, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Prior Page", %IDM_PPPrior, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Next Page", %IDM_PPNext, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "-", %IDM_PPSep, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Copy Page Image", %IDM_PPCopyPage, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Save Page Image As BMP", %IDM_PPSavePageImageAsBMP, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Save Page Image As JPG", %IDM_PPSavePageImageAsJPG, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "-", %IDM_PPSep, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Copy Page Text", %IDM_PPCopyText, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Copy Document Text", %IDM_PPCopyDocText, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "-", %IDM_PPSep, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Sort Ascending", %IDM_PPSortA, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Sort Descending", %IDM_PPSortD, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Natural Order", %IDM_PPSortN, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "-", %IDM_PPSep, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Left Justify", %IDM_PPJustify, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Toggle Line Numbers", %IDM_PPLineNumbers, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "-", %IDM_PPSep, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Open File ...", %IDM_PPOpenFile, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Sample Text ...", %IDM_PPSampleText, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "-", %IDM_PPSep, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Save As ...", %IDM_PPSaveAs, %MF_Enabled
   Menu Add String, PPG.hPopupGraphic, "Open Saved File (External Client)", %IDM_PPOpenSavedAsFile, %MF_Enabled
End Sub

Sub PPSubClassToolbarTextBoxes
   PPG.OldProc = SetWindowLong(GetDlgItem(PPG.hDlg, %IDC_PPMinPage), %GWL_WndProc, CodePtr(PPNewTextProc))  'subclass
   PPG.OldProc = SetWindowLong(GetDlgItem(PPG.hDlg, %IDC_PPMaxPage), %GWL_WndProc, CodePtr(PPNewTextProc))  'subclass
   'new context menu
   Menu New PopUp To PPG.hPopupText
   Menu Add String, PPG.hPopupText, "Copy",   %IDM_PPCopy,  %MF_Enabled
   Menu Add String, PPG.hPopupText, "Cut",    %IDM_PPCut,  %MF_Enabled
   Menu Add String, PPG.hPopupText, "Paste",  %IDM_PPPaste,  %MF_Enabled
   Menu Add String, PPG.hPopupText, "Delete", %IDM_PPDelete,  %MF_Enabled
End Sub

Function PPNewTextProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus hWnd
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu PPG.hPopupText, %TPM_LeftAlign, x, y, 0, PPG.hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(PPG.OldProc, hWnd, Msg, wParam, lParam)
End Function

Sub PPSetPrinterProperties
   XPrint Get Size To PPG.PaperW, PPG.PaperH
   XPrint Get PPI To PPG.PrinterPPIx,PPG.PrinterPPIy
   XPrint Get Margin To PPG.DeadZoneLeft, PPG.DeadZoneTop, PPG.DeadZoneRight, PPG.DeadZoneBottom
   PPD.PaperSizeW = PPG.PaperW / PPG.PrinterPPIx
   PPD.PaperSizeH = PPG.PaperH / PPG.PrinterPPIy
End Sub

Sub PPPrintMarginOutline
   Local x0,y0,x1,y1,XCenter,YCenter As Long, SF, Rx, Ry As Single

   'working info
   SF = PPG.PreviewW / (PPD.PaperSizeW * PPG.ScreenPPIx)
   Rx = PPG.ScreenPPIx/PPG.PrinterPPIx
   Ry = PPG.ScreenPPIy/PPG.PrinterPPIy
   XCenter = PPG.PreviewX0 + PPG.PreviewW/2
   YCenter = (PPG.PreviewY0 + PPG.PreviewH) / 2

   'Horizontal Lines
   x0 = PPG.PreviewX0 : x1 = x0 + PPG.PreviewW
   'Bottom of Top Dead Zone
   y0 = PPG.PreviewY0 + PPG.DeadZoneTop * Ry * SF
   Graphic Line (x0,y0)-(x1,y0)
   'Bottom of Header
   y0 += PPG.HeaderHeight * PPG.ScreenPPIy * SF
   Graphic Line (x0,y0)-(x1,y0)
   'Bottom of Top Margin
   y0 += PPD.MarginTop * PPG.ScreenPPIy * SF
   Graphic Line (x0,y0)-(x1,y0)
   'Top of Bottom Dead Zone
   y0 = PPG.PreviewY0 + PPG.PreviewH - PPG.DeadZoneBottom * Rx * SF
   Graphic Line (x0,y0)-(x1,y0)
   'Top of Bottom Header
   y0 -= PPG.FooterHeight * PPG.ScreenPPIy * SF
   Graphic Line (x0,y0)-(x1,y0)
   'Top of Bottom Margin
   y0 -= PPD.MarginBottom * PPG.ScreenPPIy * SF
   Graphic Line (x0,y0)-(x1,y0)

   'Vertical Lines
   y0 = PPG.PreviewY0
   y1 = PPG.PreviewY0 + PPG.PreviewH
   'Right of Left Dead Zone
   x0 = PPG.PreviewX0 + PPG.DeadZoneLeft * Rx * SF
   Graphic Line (x0,y0)-(x0,y1)
   'Right of Left Margin
   x0 += PPD.MarginLeft * PPG.ScreenPPIx * SF
   Graphic Line (x0,y0)-(x0,y1)
   'Left of Right Dead Zone
   x0 = PPG.PreviewX0 + PPG.PreviewW - PPG.DeadZoneRight * Ry * SF
   Graphic Line (x0,y0)-(x0,y1)
   'Left of Right Margin
   x0 -= PPD.MarginRight * PPG.ScreenPPIx * SF
   Graphic Line (x0,y0)-(x0,y1)

   'visual helper box/line
   Graphic Box (PPG.TextX0,PPG.TextY0)-(PPG.TextX1,PPG.TextY1),0, %Red   'shown where text area is located
'   Graphic Line (Xcenter,PPG.PreviewY0-20)-(Xcenter,PPG.PreviewY0 + PPG.PreviewH + 20), %Red
'   Graphic Line (PPG.PreviewX0-20,YCenter)-(PPG.PreviewX0 + PPG.PreviewW + 20, YCenter ), %Red

End Sub

Sub PPPrintHeader
   Local XCenter As Long, SF, Rx, Ry As Single
   Local wCont, hCont, wImg, hImg, wNew,hNew, x,y As Single
   'working info
   SF = PPG.PreviewW / (PPD.PaperSizeW * PPG.ScreenPPIx)
   Rx = PPG.ScreenPPIx/PPG.PrinterPPIx
   Ry = PPG.ScreenPPIy/PPG.PrinterPPIy
   XCenter = PPG.PreviewX0 + PPG.PreviewW/2

   'print image
   If PPD.ShowHeaderImage Then
      If PPD.HeaderNatural Then
         'print header at true size
         x = XCenter - PPG.HeaderImageW * SF / 2
         y = PPG.PreviewY0 + PPG.DeadZoneTop * Ry * SF
         Graphic Stretch PPG.hImageHeader, 0, (0,0)-(PPG.HeaderImageW-1,PPG.HeaderImageH-1) To (x,y)-(x+PPG.HeaderImageW*SF,y+PPG.HeaderImageH*SF),%Mix_CopySrc, %HalfTone
         If PPD.HeaderImageBorder Then Graphic Box (x,y)-(x+PPG.HeaderImageW*SF,y+PPG.HeaderImageH*SF), 0, %Black
      Else
         wCont = PPD.HeaderImageContW * (PPG.ScreenPPIx * SF)
         hCont = PPD.HeaderImageContH * (PPG.ScreenPPIy * SF)
         wImg  = PPG.HeaderImageW * SF
         hImg  = PPG.HeaderImageH * SF
         wNew = wImg / Max(wImg / wCont, hImg / hCont)
         hNew = hImg / Max(wImg / wCont, hImg / hCont)
         x = XCenter - wNew/2
         y = PPG.PreviewY0 + PPG.DeadZoneTop * Ry * SF
         Graphic Stretch PPG.hImageHeader, 0, (0,0)-(PPG.HeaderImageW-1,PPG.HeaderImageH-1) To (x,y)-(x+wNew,y+hNew),%Mix_CopySrc, %HalfTone
         If PPD.HeaderImageBorder Then Graphic Box (x,y)-(x+wNew,y+hNew), 0, %Black
      End If
   End If

   Graphic Set Font PPG.hFontHeaderSF

   'header text - Left
   Local w,h As Long
   y = PPG.PreviewY0 + PPG.DeadZoneTop * Ry * SF
   x = PPG.PreviewX0 + PPG.DeadZoneLeft * Rx * SF + PPD.MarginLeft * PPG.ScreenPPIx * Sf
   Graphic Set Pos (x,y) : Graphic Print PPReplaceTitle(PPD.TopLeftText)

   'header text - Right
   Graphic Text Size PPReplaceTitle(PPD.TopRightText) To w,h
   x = PPG.PreviewX0 + PPG.PreviewW - PPG.DeadZoneRight * Rx * SF - PPD.MarginRight * PPG.ScreenPPIx * SF - w
   Graphic Set Pos (x,y) : Graphic Print PPReplaceTitle(PPD.TopRightText)

   'header text - Center
   If PPD.HeaderNatural Then
      'natural sized image
      If PPD.ShowHeaderImage Then y += PPG.HeaderImageH * SF
      Graphic Text Size PPReplaceTitle(PPD.TopCenterText) To w,h
      x = XCenter - w/2
      Graphic Set Pos (x,y) : Graphic Print PPReplaceTitle(PPD.TopCenterText)
   Else
      If PPD.ShowHeaderImage Then y += PPD.HeaderHeight * PPG.ScreenPPIy * SF
      Graphic Text Size PPReplaceTitle(PPD.TopCenterText) To w,h
      x = XCenter - w/2
      Graphic Set Pos (x,y) : Graphic Print PPReplaceTitle(PPD.TopCenterText)
   End If
End Sub

Sub PPPrintFooter
   Local XCenter As Long, SF, Rx, Ry As Single
   Local wCont, hCont, wImg, hImg, wNew,hNew, x,y As Single
   'working info
   SF = PPG.PreviewW / (PPD.PaperSizeW * PPG.ScreenPPIx)
   Rx = PPG.ScreenPPIx/PPG.PrinterPPIx
   Ry = PPG.ScreenPPIy/PPG.PrinterPPIy
   XCenter = PPG.PreviewX0 + PPG.PreviewW/2

   'final image position information
   If PPD.ShowFooterImage Then
      If PPD.FooterNatural Then
         'print footer image at true size
         x = XCenter - PPG.HeaderImageW * SF / 2
         y = PPG.PreviewY0 + PPG.PreviewH - PPG.DeadZoneBottom * Rx * SF - PPG.FooterImageH * SF
         Graphic Stretch PPG.hImageFooter, 0, (0,0)-(PPG.FooterImageW-1,PPG.FooterImageH-1) To (x,y)-(x+PPG.FooterImageW*SF,y+PPG.FooterImageH*SF),%Mix_CopySrc, %HalfTone
         If PPD.FooterImageBorder Then Graphic Box (x,y)-(x+PPG.FooterImageW*SF,y+PPG.FooterImageH*SF), 0, %Black
      Else
         wCont = PPD.FooterImageContW * (PPG.ScreenPPIx * SF)
         hCont = PPD.FooterImageContH * (PPG.ScreenPPIy * SF)
         wImg  = PPG.FooterImageW * SF
         hImg  = PPG.FooterImageH * SF
         wNew = wImg / Max(wImg / wCont, hImg / hCont)
         hNew = hImg / Max(wImg / wCont, hImg / hCont)
         x = XCenter - wNew/2
         y = PPG.PreviewY0 + PPG.PreviewH - PPG.DeadZoneBottom * Rx * SF - PPD.FooterHeight * PPG.ScreenPPIy * SF
         Graphic Stretch PPG.hImageFooter, 0, (0,0)-(PPG.FooterImageW-1,PPG.FooterImageH-1) To (x,y)-(x+wNew-1,y+hNew-1),%Mix_CopySrc, %HalfTone
         If PPD.FooterImageBorder Then Graphic Box (x,y)-(x+wNew-1,y+hNew-1), 0, %Black
      End If
   End If

   Graphic Set Font PPG.hFontFooterSF

   'footer text - Left
   Local w,h As Long
   Graphic Text Size PPReplaceTitle(PPD.BottomLeftText) To w,h
   y = PPG.PreviewY0 + PPG.PreviewH - PPG.DeadZoneBottom * Ry * SF - h
   x = PPG.PreviewX0 + PPG.DeadZoneLeft * Rx * SF + PPD.MarginLeft * PPG.ScreenPPIx * SF
   Graphic Set Pos (x,y) : Graphic Print PPReplaceTitle(PPD.BottomLeftText)

   'center
   If PPD.ShowFooterImage = 0 Then
      Graphic Text Size PPReplaceTitle(PPD.BottomCenterText) To w,h
      x = XCenter - w/2
      Graphic Set Pos (x,y) : Graphic Print PPReplaceTitle(PPD.BottomCenterText)
   End If

   'footer text - Right
   Graphic Text Size PPReplaceTitle(PPD.BottomRightText) To w,h
   x = PPG.PreviewX0 + PPG.PreviewW - PPG.DeadZoneRight * Rx * SF - PPD.MarginRight * PPG.ScreenPPIx * SF - w
   Graphic Set Pos (x,y) : Graphic Print PPReplaceTitle(PPD.BottomRightText)
End Sub

Function PPReplaceTitle(temp As StringZ * %Max_Path) As String
   Select Case temp$
      Case "<dt>"       : Function = PPG.PrintDate + "  " + PPG.PrintTime
      Case "<t>"        : Function = PPG.PrintTime
      Case "<d>"        : Function = PPG.PrintDate
      Case "<page>"     : Function = "Page" + Str$(PPG.CurrentPage)
      Case "<pagen>"    : Function = "Page" + Str$(PPG.CurrentPage) + " of " + Trim$(Str$(PPG.MaxPages))
      Case "<filename>"
         If Len(PPD.FileName) = 0 Then Function = "<No FileName>" Else  Function = PathName$(Namex,PPD.FileName)
      Case "<filepath>"
         If Len(PPD.FileName) = 0 Then Function = "<No FileName>" Else  Function = PPD.FileName
      Case Else         : Function = temp$
   End Select
End Function

Sub PPSetLinesPerPageAtSF100
   Local wCont,hCont,VirtualW, VirtualH, PreviewW, PreviewH, PreviewX0, PreviewY0 As Long
   Local TextX0, TextX1, TextY0, TextY1, TextLineH As Long
   Local tmi As TextMetric, hDC As Dword, Rx, Ry As Single
   'set text font to SF = 1
   Graphic Set Font PPG.hFontText

   'set Preview and Virtual dimensions
   Dialog Get Client PPG.hDlg To wCont, hCont : hCont -= %PPToolbar_Height
   PreviewW = PPG.ScreenPPIx * PPD.PaperSizeW   'original width in pixels
   PreviewH = PPG.ScreenPPIy * PPD.PaperSizeH   'original height in pixels
   PreviewY0 = 20
   PreviewX0 = Max(20,(wCont-IIf(Graphic(Client.X)<Graphic(Canvas.X),Metrics(Scroll.Vert),0)- PreviewW)/2)
   VirtualW = PreviewW * 1.1
   VirtualH = PreviewH * 1.1
   Graphic Set Virtual Max(PPG.VirtualW,wCont), Max(PPG.VirtualH,hCont)

   'working info
   Rx = PPG.ScreenPPIx/PPG.PrinterPPIx
   Ry = PPG.ScreenPPIy/PPG.PrinterPPIy

   'upper/left and lower/right points where text can be printed
   TextX0 = PreviewX0 + PPG.DeadZoneLeft  * Rx + PPD.MarginLeft * PPG.ScreenPPIx
   TextX1 = PreViewX0 + PreviewW - PPG.DeadZoneRight  * Rx - PPD.MarginRight * PPG.ScreenPPIx
   TextY0 = PreviewY0 + PPG.DeadZoneTop   * Ry + (PPG.HeaderHeight+PPD.MarginTop) * PPG.ScreenPPIy
   TextY1 = PreviewY0 + PreviewH - PPG.DeadZoneBottom * Ry  - (PPG.FooterHeight+PPD.MarginBottom) * PPG.ScreenPPIy
   PPG.MaxTextWidthSF100 = TextX1 - TextX0

   'get unchanging line count, based on 100% SF
   Graphic Get DC To hDC
   GetTextMetrics hDC, tmi
   TextLineH = tmi.tmExternalLeading + tmi.tmHeight
   PPG.LinesPerPage = (TextY1 - TextY0) / TextLineH
End Sub

Function PPWordWrap(temp As String) As String     'WL=WordList()  mw=MaxWidth (pixel)
   Local i As Long, CL, Rtn As String, w,h As Single
   Dim WL(ParseCount(temp," ")-1) As String
   Parse temp, WL(), " "
   For i = 0 To UBound(WL)
      Graphic Text Size (CL + " " + WL(i)) To w,h        'returns pixels
      If w >= PPG.MaxTextWidthSF100 Or i=UBound(WL) Then
         Rtn = Rtn+IIf$(Len(Rtn),$CrLf,"")+ CL + IIf$(i=UBound(WL), IIf$(w<PPG.MaxTextWidthSF100," ",$CrLf)+WL(i),"")
         CL = WL(i)
      Else
         CL = CL + IIf$(i=0,""," ") + WL(i)
      End If
   Next i
   Function = Rtn
End Function

Sub PPCopyCurrentPageText
   'copy only the lines for the specified page
   Local FirstLine, LastLine, i As Long, temp$
   FirstLine = (PPG.CurrentPage-1)*PPG.LinesPerPage     'zero based array
   LastLine = PPG.CurrentPage * PPG.LinesPerPage - 1    'zero based array
   PPG.TextLineH = (PPG.TextY1 - PPG.TextY0) / PPG.LinesPerPage
   If LastLine > UBound(PPPrintArray) Then LastLine = UBound(PPPrintArray)
   For i = FirstLine To LastLine
      temp$ += PPPrintArray(i) + $CrLf
   Next i
   Clipboard Reset
   Clipboard Set Text Trim$(temp$,$CrLf)
End Sub

Sub PPCopyCurrentPageImage
   Local hBMP As Dword
   Graphic Bitmap New PPG.PreviewW, PPG.PreviewH To hBMP
   Graphic Attach hBMP, 0
   Graphic Copy PPG.hDlg, %IDC_PPGraphic, (PPG.PreviewX0,PPG.PreviewY0)-(PPG.PreviewX0+PPG.PreviewW-1,PPG.PreviewY0+PPG.PreviewH-1) To (0,0)
   Clipboard Reset
   Clipboard Set Bitmap hBmp
   Graphic Bitmap End
   Graphic Attach PPG.hDlg, %IDC_PPGraphic, ReDraw
End Sub

Sub PPSavePageImageAsBMP
   Local hParent As Dword, title$, folder$, filter$, start$, defaultext$, flags&, filevar$
   Local hBMP As Dword
   hParent = PPG.hDlg
   title$ = "Save Page As BMP"
   folder$ = IIf$(IsFile(PPD.FileName), PathName$(Path,PPD.FileName), Exe.Path$)
   filter$ = Chr$("BMP Image (*.bmp)", 0, "*.bmp", 0)
   start$ = ""
   defaultext$ = ".bmp"
   flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
   Display Savefile hParent, 100, 100, title$, folder$, filter$, start$, defaultext$, flags& To filevar$
   If Len(filevar$) Then
      Graphic Bitmap New PPG.PreviewW, PPG.PreviewH To hBMP
      Graphic Attach hBMP, 0
      Graphic Copy PPG.hDlg, %IDC_PPGraphic, (PPG.PreviewX0,PPG.PreviewY0)-(PPG.PreviewX0+PPG.PreviewW-1,PPG.PreviewY0+PPG.PreviewH-1) To (0,0)
      Graphic Save filevar$
      Graphic Bitmap End
      Graphic Attach PPG.hDlg, %IDC_PPGraphic, ReDraw
   End If
End Sub

Sub PPSavePageImageAsJPG
   Local hParent As Dword, title$, folder$, filter$, start$, defaultext$, flags&, filevar$
   Local hBMP As Dword
   hParent = PPG.hDlg
   title$ = "Save Page As JPG"
   folder$ = IIf$(IsFile(PPD.FileName), PathName$(Path,PPD.FileName), Exe.Path$)
   filter$ = Chr$("JPG Image (*.jpg)", 0, "*.jpg", 0)
   start$ = ""
   defaultext$ = ".jpg"
   flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
   Display Savefile hParent, 100, 100, title$, folder$, filter$, start$, defaultext$, flags& To filevar$
   If Len(filevar$) Then
      Local token As Dword, StartupInput As GdiplusStartupInput
      Local sEncoderClsid As Guid, pImage,pGraphics As Dword
      'initialize GDIPlus
      StartupInput.GdiplusVersion = 1
      GdiplusStartup(token, StartupInput, ByVal %NULL)

      'create bitmap of just the page image
      Graphic Bitmap New PPG.PreviewW, PPG.PreviewH To hBMP
      Graphic Attach hBMP, 0
      Graphic Copy PPG.hDlg, %IDC_PPGraphic, (PPG.PreviewX0,PPG.PreviewY0)-(PPG.PreviewX0+PPG.PreviewW-1,PPG.PreviewY0+PPG.PreviewH-1) To (0,0)

      'save image as JPG
      sEncoderClsID = Guid$(GDIPLusGetEncoderClsid("image/jpeg"))
      GdipCreateBitmapFromHBITMAP(hBMP, ByVal %Null, pImage)
      GdipSaveImageToFile(pImage, (filevar$),sEncoderClsid, ByVal %Null)

      'cleanup
      If pImage Then GdipDisposeImage(pImage)
      If pGraphics Then GdipDeleteGraphics(pGraphics)
      GdiplusShutdown token      ' Shutdown GDI+

      'kill bitmap and re-attach to %IDC_PPGraphic
      Graphic Bitmap End
      Graphic Attach PPG.hDlg, %IDC_PPGraphic, ReDraw
   End If
End Sub


Sub PPSelectHeaderFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   PPG.hHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font PPG.hDlg, 100,100, tempPPD.FontNameH, tempPPD.FontPointsH, tempPPD.FontStyleH, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx PPG.hHook
   If Len(fName) Then
      tempPPD.FontNameH = fName : tempPPD.FontPointsH = fPoints : tempPPD.FontStyleH = fStyle
   End If
End Sub

Sub PPSelectFooterFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   PPG.hHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font PPG.hDlg, 100,100, tempPPD.FontNameF, tempPPD.FontPointsF, tempPPD.FontStyleF, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx PPG.hHook
   If Len(fName) Then
      tempPPD.FontNameF = fName : tempPPD.FontPointsF = fPoints : tempPPD.FontStyleF = fStyle
   End If
End Sub

Sub PPSelectTextFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   PPG.hHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font PPG.hDlg, 100,100, tempPPD.FontName, tempPPD.FontPoints, tempPPD.FontStyle, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx PPG.hHook
   If Len(fName) Then
      tempPPD.FontName = fName : tempPPD.FontPoints = fPoints : tempPPD.FontStyle = fStyle
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal PPG.hHook, ByVal nCode, ByVal WParam, ByVal LParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx PPG.hHook
    If nCode = %HCBT_CREATEWND Then
        cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub PPSelectImage(ImageName As StringZ * %Max_Path, title$)
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Images (.bmp,.jpg,.gif,.png)" + $Nul + "*.bmp;*.jpg;*.gif;*.png" + $Nul
    startfolder$ = IIf$(IsFile(ImageName), ImageName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (ImageName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile PPG.hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then ImageName = filevar$
End Sub

Function PPSelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&, CustomColorList As PPCustomColors
   Dim CustomColorList(15) As Long
   Display Color PPG.hDlg, 200, 200, startcolor&, CustomColorList, %CC_PreventFullOpen To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub PPBuildPrintArray
   Local i,j,k,iCount As Long, temp$, FFText$

   'determine FF string to look for
   If PPD.CustomFF Then FFText$ = PPD.CustomFFText Else FFText$ = Chr$(12)

   'get array of lines of text ($crlf is line separator)
   ReDim PPPrintArray(ParseCount(PPGlobalText, $CrLf)-1)
   Parse PPGlobalText, PPPrintArray(), $CrLf
   If PPD.WordWrap Then
      For i = 0 To UBound(PPPrintArray)
         PPPrintArray(i) = PPWordWrap (PPPrintArray(i))
      Next i
   End If

   'split the lines into array elements
   temp$ = Join$(PPPrintArray(),$CrLf)
   ReDim PPPrintArray(ParseCount(temp$,$CrLf)-1)
   Parse temp$, PPPrintArray(), $CrLf

   'Justify if necessary
   If PPD.Justify Then
      For i = 0 To UBound(PPPrintArray)
         PPPrintArray(i) = LTrim$(PPPrintArray(i))
      Next i
   End If

   'Sort if necessary
   Select Case PPD.SortMethod
      Case 1 : Array Sort PPPrintArray(), Collate UCase, Ascend
      Case 2 : Array Sort PPPrintArray(), Collate UCase, Descend
   End Select

   'now add extra lines whenever a form feed is found
   iCount = 0 : i = 0
   Do
      Incr iCount
      If Trim$(PPPrintArray(i)) = FFText$ Then
         PPPrintArray(i) = ""     'get rid of the FFText$
         k = PPG.LinesPerPage - iCount
         ReDim Preserve PPPrintArray(UBound(PPPrintArray) + k)  'add needed empty lines
         For j = 1 To k
            Array Insert PPPrintArray(i)
         Next j
         i = i + k
         iCount = 0
      End If
      Incr i
   Loop Until i > UBound(PPPrintArray)

   'determine page count
   PPG.MaxPages = (UBound(PPPrintArray)\PPG.LinesPerPage)
   If UBound(PPPrintArray) Mod PPG.LinesPerPage Then PPG.MaxPages = PPG.MaxPages + 1
End Sub

Sub PPPrintText   'print only the lines for the specified page
   Local FirstLine, LastLine, i,TextW,TextH ,MaxLine, iLine,w,wMax,h  As Long, hTemp,hTempM As Dword, PointSize As Single

   'get first/last line
   FirstLine = (PPG.CurrentPage-1)*PPG.LinesPerPage     'zero based array
   LastLine = PPG.CurrentPage * PPG.LinesPerPage - 1    'zero based array
   If LastLine > UBound(PPPrintArray) Then LastLine = UBound(PPPrintArray)

   'set line height
   PPG.TextLineH = (PPG.TextY1 - PPG.TextY0) / PPG.LinesPerPage
   Do While (PPG.TextLineH * PPG.LinesPerPage) > (PPG.TextY1 - PPG.TextY0)
      Decr PPG.TextLineH
   Loop

   'set font, size to match scale factor
'   Graphic Set Font PPG.hFontTextSF 'start here
   Graphic Font PPD.FontName, PPD.FontPointsSF, PPD.FontStyle

'   'get longest line to use in setting font
   For i = FirstLine To LastLine
      Graphic Text Size PPPrintArray(i) To w,h
      If w > wMax Then
         MaxLine = i    '<--- longest line
         wMax = w
      End If
   Next i

   'shrink PPG.hFontTextSF size until longest line fits within text area
   If PPD.WordWrap Then
      PointSize = PPD.FontPointsSF + 0.01
      Do
         PointSize -= 0.01
         Graphic Font PPD.FontName, PointSize, PPD.FontStyle
         Graphic Text Size PPPrintArray(MaxLine) To TextW, TextH
      Loop Until (PPG.TextX1-PPG.TextX0) > TextW
   End If

   'print the text and/or line numbers
   Graphic Text Size "0000" To w,h  'use w to set position of line numbers
   For i = FirstLine To LastLine
      If PPD.LineNumbers Then
         Graphic Set Pos(PPG.TextX0 - 1.3 * w, PPG.TextY0 + iLine * PPG.TextLineH)
         Graphic Print Format$((PPG.CurrentPage-1) * PPG.LinesPerPage + iLine+1,"0000")
      End If
      Graphic Set Pos (PPG.TextX0, PPG.TextY0 + iLine * PPG.TextLineH)
      Graphic Print PPPrintArray(i)
      Incr iLine
   Next i
End Sub

Sub PPPrintToGraphic
   Local wCont,hCont,wPreview,hPreview,ShowSecondPage As Long
   Local hSecondPage As Dword
   Local SF, Rx, Ry As Single

   'print to the right place
   Graphic Attach PPG.hDlg, %IDC_PPGraphic, ReDraw

   'clear the screen
   Graphic Color PPD.TextColor, %rgb_LightGray : Graphic Clear

   'state which page is displayed
   Control Set Text PPG.hDlg, %IDC_PPPageLabel, Str$(PPG.CurrentPage)

   'if DualPage, then work first with Page #2
   If (PPD.ZoomFactor=%PPZoom_DualPage) And (PPG.CurrentPage<PPG.MaxPages) Then
      Incr PPG.CurrentPage
      ShowSecondPage = 1
   End If

   'set Preview and Virtual dimensions
   Dialog Get Client PPG.hDlg To wCont, hCont : hCont -= %PPToolbar_Height
   wPreview = PPG.ScreenPPIx * PPD.PaperSizeW   'original width in pixels
   hPreview = PPG.ScreenPPIy * PPD.PaperSizeH   'original height in pixels
   Select Case PPD.ZoomFactor
      Case 1  'display whole page sized to fit within the dialog
         PPG.PreviewW = wPreview / Max(wPreview/wCont, hPreview/hCont) * 0.9
         PPG.PreviewH = hPreview / Max(wPreview/wCont, hPreview/hCont) * 0.9
         PPG.PreviewX0 = (wCont-IIf(Graphic(Client.X)<Graphic(Canvas.X),Metrics(Scroll.Vert),0)-PPG.PreviewW)/2
         PPG.PreviewY0 = (hCont-IIf(Graphic(Client.Y)<Graphic(Canvas.Y),Metrics(Scroll.Vert),0)-PPG.PreviewH)/2
         PPG.VirtualW = wCont
         PPG.VirtualH = hCont

      Case 2  'display dual pages - combined size fits width of dialog
         PPG.PreviewW = wPreview / Max(wPreview/wCont, hPreview/hCont) * 0.9
         PPG.PreviewH = hPreview / Max(wPreview/wCont, hPreview/hCont) * 0.9
         PPG.PreviewX0 = (wCont-IIf(Graphic(Client.X)<Graphic(Canvas.X),Metrics(Scroll.Vert),0)-PPG.PreviewW)/2
         PPG.PreviewY0 = (hCont-IIf(Graphic(Client.Y)<Graphic(Canvas.Y),Metrics(Scroll.Vert),0)-PPG.PreviewH)/2
         PPG.VirtualW = wCont
         PPG.VirtualH = hCont

      Case 3  'display page size to fit width of dialog
         PPG.PreviewW = wCont * 0.9
         PPG.PreviewH = PPG.PreviewW * (hPreview/wPreview)
         PPG.PreviewX0 = Max(20,(wCont-IIf(Graphic(Client.X)<Graphic(Canvas.X),Metrics(Scroll.Vert),0)-PPG.PreviewW)/2)
         PPG.PreviewY0 = 20
         PPG.VirtualW = wCont
         PPG.VirtualH = Max(hCont, wCont*hPreview/wPreview)

      Case Else    'display page at UL postion of 20,20  '4-.25 5-.50 6-.75 7-1.0 8-2.0 9-4.0
         PPG.PreviewW = wPreview * Val(Parse$(PPG.ZoomText, $Spc, PPD.ZoomFactor))/100
         PPG.PreviewH = hPreview * Val(Parse$(PPG.ZoomText, $Spc, PPD.ZoomFactor))/100
         If 1 Then
            PPG.PreviewX0 = Max(20,(wCont-IIf(Graphic(Client.X)<Graphic(Canvas.X),Metrics(Scroll.Vert),0)-PPG.PreviewW)/2)
            PPG.PreviewY0 = 20
         Else
            PPG.PreviewX0 = Max(20,(wCont-IIf(Graphic(Client.X)<Graphic(Canvas.X),Metrics(Scroll.Vert),0)-PPG.PreviewW)/2)
            PPG.PreviewY0 = Max(20,(hCont-IIf(Graphic(Client.Y)<Graphic(Canvas.Y),Metrics(Scroll.Horz),0)-PPG.PreviewH)/2)
         End If
         PPG.VirtualW = PPG.PreviewW * 1.1
         PPG.VirtualH = PPG.PreviewH * 1.1
   End Select
   Graphic Set Virtual IIf(ShowSecondPage,2,1) * Max(PPG.VirtualW,wCont), IIf(ShowSecondPage,2,1) * Max(PPG.VirtualH,hCont)

   'working info
   SF = PPG.PreviewW / (PPD.PaperSizeW * PPG.ScreenPPIx)
   Rx = PPG.ScreenPPIx/PPG.PrinterPPIx
   Ry = PPG.ScreenPPIy/PPG.PrinterPPIy

   'upper/left and lower/right points where text can be printed
   PPG.TextX0 = PPG.PreviewX0 + PPG.DeadZoneLeft  * Rx * SF + PPD.MarginLeft * PPG.ScreenPPIx * SF
   PPG.TextY0 = PPG.PreviewY0 + PPG.DeadZoneTop   * Ry * SF + (PPG.HeaderHeight+PPD.MarginTop) * PPG.ScreenPPIy * SF
   PPG.TextX1 = PPG.PreViewX0 + PPG.PreviewW - PPG.DeadZoneRight  * Rx * SF - PPD.MarginRight * PPG.ScreenPPIx * SF
   PPG.TextY1 = PPG.PreviewY0 + PPG.PreviewH - PPG.DeadZoneBottom * Ry * SF - (PPG.FooterHeight+PPD.MarginBottom) * PPG.ScreenPPIy * SF
   PPG.MaxTextWidthSF100 = PPG.TextX1 - PPG.TextX0

PrintPreviousPage:

   'draw shadow boxes
   Graphic Box (PPG.PreviewX0+10,PPG.PreViewY0+10)-(PPG.PreviewX0+PPG.PreViewW+10,PPG.PreviewY0+PPG.PreviewH+10), 0, %rgb_DimGray, %rgb_DimGray, 0
   Graphic Box (PPG.PreviewX0,PPG.PreViewY0)-(PPG.PreviewX0+PPG.PreviewW,PPG.PreviewY0+PPG.PreviewH), 0, PPD.TextColor, PPD.BGColor, 0
   Graphic Color PPD.TextColor, PPD.BGColor

   'draw background
   If PPD.ShowBGImage Then
      Graphic Stretch PPG.hImageBackground, 0, (0,0)-(PPG.BGImageW, PPG.BGImageH) To (PPG.PreviewX0,PPG.PreViewY0)-(PPG.PreviewX0+PPG.PreviewW,PPG.PreviewY0+PPG.PreviewH),%Mix_CopySrc, %HalfTone
   End If

   'set print time
   PPG.PrintDate = Date$
   PPG.PrintTime = Time$
   'reset font, draw header/footer
   Graphic Color PPD.TextColor, -2
   If PPD.ShowHeader Then PPPrintHeader          'print header
   If PPD.ShowFooter Then PPPrintFooter          'print footer

   'print the text
   PPPrintText                                   'print text

   'draw margin outline
   If PPD.ShowMargins Then PPPrintMarginOutline  'print outline

   If ShowSecondPage Then
      'save image of current page in memory bitmap
      Graphic Copy PPG.hDlg, %IDC_PPGraphic, (PPG.PreviewX0,PPG.PreViewY0)-(PPG.PreviewX0+PPG.PreviewW+10,PPG.PreviewY0+PPG.PreviewH+10) To (PPG.PreviewX0+PPG.PreviewW+30,PPG.PreviewY0)
      'now go back and print the previous page
      Decr PPG.CurrentPage
      ShowSecondPage = 0
      GoTo PrintPreviousPage
   End If

   'show drawing results
   Graphic ReDraw

   'put the page number on the dialog
   Dialog Set Text PPG.hDlg, "gbPrintPreview   v" + $PPVer + Space$(10) + "Page" + Str$(PPG.CurrentPage) + " of "+Str$(PPG.MaxPages)
End Sub

Sub PPSendToPrinter(Flag As Long, ByVal MinPge As Long, ByVal MaxPge As Long)
   '0=all  1=current 2=range
   Local MinPage, MaxPage, cPage As Long
   Local temp As String

   XPrint Attach PPD.PrinterName
   If PPD.Orientation Then XPrint Set Orientation 1 Else XPrint Set Orientation 2

   Select Case Flag
      Case 0   'all pages
         For cPage = 1 To PPG.MaxPages
            PPG.CurrentPage = cPage
            PPPrintCurrentPageToPrinter
            XPrint FormFeed
         Next cPage
      Case 1   'current page only
         PPPrintCurrentPageToPrinter
      Case 2   'range
         Control Get Text PPG.hDlg, %IDC_PPMinPage To temp : MinPage = Val(temp)
         Control Get Text PPG.hDlg, %IDC_PPMaxPage To temp : MaxPage = Val(temp)
         If MinPge Then MinPage = MinPge  'for direct print through
         If MaxPge Then MaxPage = MaxPge  'for direct print through
         If MinPage < 1 Then MinPage = 1
         If MinPage > PPG.MaxPages Then MinPage = PPG.MaxPages
         If MaxPage < MinPage Then MaxPage = MinPage
         If MaxPage > PPG.MaxPages Then MaxPage = PPG.MaxPages
         For cPage = MinPage To MaxPage
            PPPrintCurrentPageToPrinter
            XPrint FormFeed
         Next cPage
   End Select

   XPrint Close   'print paper
End Sub

Sub PPPrintCurrentPageToPrinter
   'set needed position variables
   XPrint Get Client To PPG.PreviewW, PPG.PreviewH
   PPG.PreviewX0 = 0
   PPG.PreviewY0 = 0
   'upper/left and lower/right points where text can be printed
   PPG.TextX0 = PPD.MarginLeft * PPG.PrinterPPIx
   PPG.TextY0 = (PPG.HeaderHeight+PPD.MarginTop) * PPG.PrinterPPIy
   PPG.TextX1 = PPG.PreviewW - PPD.MarginRight * PPG.PrinterPPIx
   PPG.TextY1 = PPG.PreviewH - (PPG.FooterHeight+PPD.MarginBottom) * PPG.PrinterPPIy

   'draw background
   If PPD.ShowBGImage Then
      XPrint Stretch PPG.hImageBackground, 0, (0,0)-(PPG.BGImageW, PPG.BGImageH) To (0,0)-(PPG.PreviewW-1,PPg.PreviewH-1)
   End If

   'set print time
   PPG.PrintDate = Date$
   PPG.PrintTime = Time$
   'print the header/footer/outlines onto the Printer
   XPrint Color PPD.TextColor, -2
   If PPD.ShowHeader Then PPPrintHeaderToPrinter
   If PPD.ShowFooter Then PPPrintFooterToPrinter
   If PPD.ShowMargins Then PPPrintMarginOutlineToPrinter
   'print the text content
   PPPrintTextToPrinter
End Sub

Sub PPPrintMarginOutlineToPrinter
   Local x0,y0,x1,y1 As Long

   'line drawing settings
   XPrint Width 2 : XPrint Style 4

   'Horizontal Lines
   x0 = 0 : x1 = PPG.PreviewW
   'Bottom of Top Dead Zone
   y0 = 0
   XPrint Line (x0,y0)-(x1,y0)
   'Bottom of Header
   y0 += PPG.HeaderHeight * PPG.PrinterPPIy
   XPrint Line (x0,y0)-(x1,y0)
   'Bottom of Top Margin
   y0 += PPD.MarginTop * PPG.PrinterPPIy
   XPrint Line (x0,y0)-(x1,y0)
   'Top of Bottom Dead Zone
   y0 = PPG.PreviewH
   XPrint Line (x0,y0)-(x1,y0)
   'Top of Bottom Header
   y0 -= PPG.FooterHeight * PPG.PrinterPPIy
   XPrint Line (x0,y0)-(x1,y0)
   'Top of Bottom Margin
   y0 -= PPD.MarginBottom * PPG.PrinterPPIy
   XPrint Line (x0,y0)-(x1,y0)

   'Vertical Lines
   y0 = 0 : y1 = PPG.PreviewH
   'Right of Left Dead Zone
   x0 = 0
   XPrint Line (x0,y0)-(x0,y1)
   'Right of Left Margin
   x0 += PPD.MarginLeft * PPG.PrinterPPIx
   XPrint Line (x0,y0)-(x0,y1)
   'Left of Right Dead Zone
   x0 = PPG.PreviewW
   XPrint Line (x0,y0)-(x0,y1)
   'Left of Right Margin
   x0 -= PPD.MarginRight * PPG.PrinterPPIx
   XPrint Line (x0,y0)-(x0,y1)
End Sub

Sub PPPrintHeaderToPrinter
   Local XCenter As Long, wCont, hCont, wImg, hImg, wNew,hNew, x,y As Single
   'working info
   XCenter = PPG.PreviewX0 + PPG.PreviewW/2

   'print image
   If PPD.ShowHeaderImage Then
      If PPD.HeaderNatural Then
         'print header image at natural size
         x = XCenter - PPG.HeaderImageW * (PPG.PrinterPPIx/PPG.ScreenPPIx) / 2
         y = PPG.PreviewY0
         XPrint Stretch PPG.hImageHeader, 0, (0,0)-(PPG.HeaderImageW-1,PPG.HeaderImageH-1) To (x,y)-(x+PPG.HeaderImageW*(PPG.PrinterPPIx/PPG.ScreenPPIx),y+PPG.HeaderImageH*(PPG.PrinterPPIy/PPG.ScreenPPIy)),%Mix_CopySrc, %HalfTone
         If PPD.HeaderImageBorder Then Graphic Box (x,y)-(x+PPG.HeaderImageW*(PPG.PrinterPPIx/PPG.ScreenPPIx),y+PPG.HeaderImageH*(PPG.PrinterPPIy/PPG.ScreenPPIy)), 0, %Black
      Else
         wCont = PPD.HeaderImageContW * PPG.PrinterPPIx
         hCont = PPD.HeaderImageContH * PPG.PrinterPPIy
         wImg  = PPG.HeaderImageW
         hImg  = PPG.HeaderImageH
         wNew = wImg / Max(wImg / wCont, hImg / hCont)
         hNew = hImg / Max(wImg / wCont, hImg / hCont)
         x = XCenter - wNew/2
         y = PPG.PreviewY0
         XPrint Stretch PPG.hImageHeader, 0, (0,0)-(PPG.HeaderImageW-1,PPG.HeaderImageH-1) To (x,y)-(x+wNew-1,y+hNew-1),%Mix_CopySrc, %HalfTone
         If PPD.HeaderImageBorder Then XPrint Box (x,y)-(x+wNew-1,y+hNew-1), 0, %Black
      End If
   End If

   XPrint Set Font PPG.hFontHeader
   'header text - Left
   Local w,h As Long
   y = PPG.PreviewY0
   x = PPG.PreviewX0 + PPD.MarginLeft * PPG.PrinterPPIx
   XPrint Set Pos (x,y) : XPrint Print PPReplaceTitle(PPD.TopLeftText)

   'header text - Right
   XPrint Text Size PPReplaceTitle(PPD.TopRightText) To w,h
   x = PPG.PreviewX0 + PPG.PreviewW - PPD.MarginRight * PPG.PrinterPPIx - w
   XPrint Set Pos (x,y) : XPrint Print PPReplaceTitle(PPD.TopRightText)

   'header text - Center
   If PPD.HeaderNatural Then
      'natural size header image
      If PPD.ShowHeaderImage Then y += PPG.HeaderImageH * (PPG.PrinterPPIy\PPG.ScreenPPIy)
      XPrint Text Size PPReplaceTitle(PPD.TopCenterText) To w,h
      x = XCenter - w/2
      XPrint Set Pos (x,y) : XPrint Print PPReplaceTitle(PPD.TopCenterText)
   Else
      If PPD.ShowHeaderImage Then y += PPD.HeaderHeight * PPG.PrinterPPIy
      XPrint Text Size PPReplaceTitle(PPD.TopCenterText) To w,h
      x = XCenter - w/2
      XPrint Set Pos (x,y) : XPrint Print PPReplaceTitle(PPD.TopCenterText)
   End If
End Sub

Sub PPPrintFooterToPrinter
   Local XCenter As Long, wCont, hCont, wImg, hImg, wNew,hNew, x,y As Single
   'working info
   XCenter = PPG.PreviewX0 + PPG.PreviewW/2

   'final image position information
   If PPD.ShowFooterImage Then
      If PPD.FooterNatural Then
         'print footer image at natural size
         x = XCenter - PPG.HeaderImageW * (PPG.PrinterPPIx/PPG.ScreenPPIx) / 2
         y = PPG.PreviewY0 + PPG.PreviewH - PPG.HeaderImageH * (PPG.PrinterPPIy/PPG.ScreenPPIy)
         XPrint Stretch PPG.hImageFooter, 0, (0,0)-(PPG.FooterImageW-1,PPG.FooterImageH-1) To (x,y)-(x+PPG.HeaderImageW*(PPG.PrinterPPIx/PPG.ScreenPPIx),y+PPG.HeaderImageH*(PPG.PrinterPPIy/PPG.ScreenPPIy)),%Mix_CopySrc, %HalfTone
         If PPD.FooterImageBorder Then XPrint Box (x,y)-(x+PPG.HeaderImageW*(PPG.PrinterPPIx/PPG.ScreenPPIx),y+PPG.HeaderImageH*(PPG.PrinterPPIy/PPG.ScreenPPIy)), 0, %Black
      Else
         wCont = PPD.FooterImageContW * PPG.PrinterPPIx
         hCont = PPD.FooterImageContH * PPG.PrinterPPIy
         wImg  = PPG.FooterImageW
         hImg  = PPG.FooterImageH
         wNew = wImg / Max(wImg / wCont, hImg / hCont)
         hNew = hImg / Max(wImg / wCont, hImg / hCont)
         x = XCenter - wNew/2
         y = PPG.PreviewY0 + PPG.PreviewH - PPD.HeaderHeight * PPG.PrinterPPIy
         XPrint Stretch PPG.hImageFooter, 0, (0,0)-(PPG.FooterImageW-1,PPG.FooterImageH-1) To (x,y)-(x+wNew-1,y+hNew-1),%Mix_CopySrc, %HalfTone
         If PPD.FooterImageBorder Then XPrint Box (x,y)-(x+wNew-1,y+hNew-1), 0, %Black
      End If
   End If

   XPrint Set Font PPG.hFontFooter
   'footer text - Left
   Local w,h As Long
   XPrint Text Size PPReplaceTitle(PPD.BottomLeftText) To w,h
   y = PPG.PreviewY0 + PPG.PreviewH - h
   x = PPG.PreviewX0 + PPD.MarginLeft * PPG.PrinterPPIx
   XPrint Set Pos (x,y) : XPrint Print PPReplaceTitle(PPD.BottomLeftText)

   'footer center
   If PPD.ShowFooterImage = 0 Then
      XPrint Text Size PPReplaceTitle(PPD.BottomCenterText) To w,h
      x = XCenter - w/2
      XPrint Set Pos (x,y) : XPrint Print PPReplaceTitle(PPD.BottomLeftText)
   End If

   'footer text - Right
   XPrint Text Size PPReplaceTitle(PPD.BottomRightText) To w,h
   x = PPG.PreviewX0 + PPG.PreviewW - PPD.MarginRight * PPG.PrinterPPIx - w
   XPrint Set Pos (x,y) : XPrint Print PPReplaceTitle(PPD.BottomRightText)
End Sub

Sub PPPrintTextToPrinter
   'print only the lines for the specified page
   Local FirstLine, LastLine, i, w,h, iLine  As Long
   XPrint Set Font PPG.hFontText
   XPrint Text Size "0000" To w,h
   FirstLine = (PPG.CurrentPage-1)*PPG.LinesPerPage     'zero based array
   LastLine = PPG.CurrentPage * PPG.LinesPerPage - 1    'zero based array
   PPG.TextLineH = (PPG.TextY1 - PPG.TextY0) / PPG.LinesPerPage
   If LastLine > UBound(PPPrintArray) Then LastLine = UBound(PPPrintArray)
   For i = FirstLine To LastLine
      If PPD.LineNumbers Then
         XPrint Set Pos(PPG.TextX0 - 1.3 * w, PPG.TextY0 + iLine * PPG.TextLineH)
         XPrint Print Format$((PPG.CurrentPage-1) * PPG.LinesPerPage + iLine+1,"0000")
      End If
      XPrint Set Pos (PPG.TextX0, PPG.TextY0 + iLine * PPG.TextLineH)
      XPrint Print PPPrintArray(i)
      Incr iLine
   Next i
End Sub

Sub PPSaveAs
   Local hParent As Dword, title$, folder$, filter$, start$, defaultext$, flags&, filevar$
   hParent = PPG.hDlg
   title$ = "Save Displayed Text As"
   folder$ = IIf$(IsFile(PPD.FileName), PathName$(Path,PPD.FileName), Exe.Path$)
   filter$ = Chr$("Text Files (" + PPD.TextExtensions + ")", 0, PPD.TextExtensions, 0)
   start$ = ""
   defaultext$ = ".txt"
   flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
   Display Savefile hParent, 100, 100, title$, folder$, filter$, start$, defaultext$, flags& To filevar$
   If Len(filevar$) Then
      PPG.SavedAsFile = filevar$
      Open PPG.SavedAsFile For Output As #1
      Print #1, Join$(PPPrintArray(),$CrLf);
      Close #1
   End If
End Sub

Function PPSelectFile() As String
    Local hParent As Dword, title$,startfolder$, filter$, startfile$, defaultext$, flags&, filevar$
    hParent = PPG.hDlg
    title$ = "Open Text File"
    filter$ = Chr$("Text Files (" + PPD.TextExtensions + ")",0,PPD.TextExtensions,0)
    startfolder$ = IIf$(IsFile(PPD.FileName), PathName$(Path,PPD.FileName), Exe.Path$)     'initial folder to be displayed
    startfile$ = ""
    defaultext$ = "txt"
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hParent, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$
    If Len(filevar$) Then Function = filevar$
End Function

Function PPSampleText() As String
   Local temp As String
   Select Case PPG.SampleText
      Case 0
         temp = "                           Welcome to gbPrintPreview"
         temp = temp + $CrLf + $CrLf + "gbPrintPreview allows programmers to add print preview of text files to their applications. "
         temp = temp + "As a DLL, gbPrintPreview can be easily added to easily applications with only a few modifications. Source code is also available and allows the programmer to integrate gbPrintPreview features directly into their applications.""
         temp = temp + "A stand alone file viewer, which includes gbPrintPreview features, is also included in the gbPrintPreview distribution"
         temp = temp + $CrLf + $CrLf
         temp = temp + "Preview of files can be done at various zoom factors, up to 400%. "
         temp = temp + "Header and footers are supported, each with the option to include images."
         temp = temp + "Printer selection, margin setting, portrait/landscape selection, page numbering are just a few of gbPrintPreview's features."
         temp = temp + "Printing of individual pages, a page range, or the entire document is supported.
         temp = temp + $CrLf + $CrLf
         temp = temp + "gbPrintPreview is available at http://www.garybeene.com/sw/gbprintpreviewnippets.htm" + $CrLf + $CrLf
         Function = Trim$(Repeat$(10,temp), $CrLf)
      Case 1
         temp = "                           Welcome to gbPrintPreview"
         temp = temp + $CrLf + $CrLf + "gbPrintPreview allows programmers to add print preview of text files to their applications. "
         temp = temp + "As a DLL, gbPrintPreview can be easily added to easily applications with only a few modifications. Source code is also available and allows the programmer to integrate gbPrintPreview features directly into their applications.""
         temp = temp + $CrLf + ".Page" + $CrLf
         temp = temp + "A stand alone file viewer, which includes gbPrintPreview features, is also included in the gbPrintPreview distribution"
         temp = temp + $CrLf + ".Page" + $CrLf
         temp = temp + "Preview of files can be done at various zoom factors, up to 400%. "
         temp = temp + "Header and footers are supported, each with the option to include images."
         temp = temp + $CrLf + $CrLf + "Printer selection, margin setting, portrait/landscape selection, page numbering are just a few of gbPrintPreview's features."
         temp = temp + "Printing of individual pages, a page range, or the entire document is supported.
         temp = temp + $CrLf + ".Page" + $CrLf
         temp = temp + "gbPrintPreview is available at http://www.garybeene.com/sw/gbprintpreviewnippets.htm" + $CrLf + $CrLf
         Function = Trim$(temp,$CrLf)
      Case 2
         temp = " abc"
         temp = temp + $CrLf + "    def"
         temp = temp + $CrLf + "    ghi"
         temp = temp + $CrLf + "jkl"
         temp = temp + $CrLf + "mno"
         temp = temp + $CrLf + "  pqr"
         temp = temp + $CrLf + "  stu" + $CrLf
         temp = Repeat$(10,temp)
         Function = Trim$(temp,$CrLf)
      Case 3
         temp = "                           Welcome to gbPrintPreview"
         temp = temp + $CrLf + $CrLf + "gbPrintPreview allows programmers to add print preview of text files to their applications. "
         temp = temp + "As a DLL, gbPrintPreview can be easily added to easily applications with only a few modifications. Source code is also available and allows the programmer to integrate gbPrintPreview features directly into their applications.""
         temp = temp + "A stand alone file viewer, which includes gbPrintPreview features, is also included in the gbPrintPreview distribution"
         temp = temp + $CrLf + $CrLf
         temp = temp + "Preview of files can be done at various zoom factors, up to 400%. "
         temp = temp + "Header and footers are supported, each with the option to include images."
         temp = temp + "Printer selection, margin setting, portrait/landscape selection, page numbering are just a few of gbPrintPreview's features."
         temp = temp + "Printing of individual pages, a page range, or the entire document is supported.
         temp = temp + $CrLf + $CrLf
         temp = temp + "gbPrintPreview is available at http://www.garybeene.com/sw/gbprintpreviewnippets.htm" + $CrLf + $CrLf
         Function = Trim$(Repeat$(5000,temp), $CrLf)
   End Select
   Incr PPG.SampleText
   If PPG.Sampletext > 3 Then PPG.SampleText = 0
End Function

Sub PPPrintGetTempPPD
   Local temp As String

   'Main Body
   Control Get Check PPG.hSetupDlg, %IDC_PPSOrientation To tempPPD.Orientation
   Control Get Check PPG.hSetupDlg, %IDC_PPSShowBGImage To tempPPD.ShowBGImage
   Control Get Check PPG.hSetupDlg, %IDC_PPSGrayScaleBG To tempPPD.GrayScaleBG
   Control Get Check PPG.hSetupDlg, %IDC_PPSAutoClose To tempPPD.AutoClose
   Control Get Check PPG.hSetupDlg, %IDC_PPSLineNumbers To tempPPD.LineNumbers
   Control Get Check PPG.hSetupDlg, %IDC_PPSMarginOutlines To tempPPD.ShowMargins
   Control Get Check PPG.hSetupDlg, %IDC_PPSCustomFF To tempPPD.CustomFF
   Control Get Check PPG.hSetupDlg, %IDC_PPSLightenBG To tempPPD.LightenBG
   Control Get Check PPG.hSetupDlg, %IDC_PPSWordWrap To tempPPD.WordWrap

   Control Get Text PPG.hSetupDlg, %IDC_PPSCustomFFText To tempPPD.CustomFFText
   Control Get Text PPG.hSetupDlg, %IDC_PPSExtensions To tempPPD.TextExtensions
   Control Get Text PPG.hSetupDlg, %IDC_PPSBGImageName To tempPPD.BGImageName
   Control Get Text PPG.hSetupDlg, %IDC_PPSFileName To tempPPD.FileName
   Control Get Text PPG.hSetupDlg, %IDC_PPSMT To temp : tempPPD.MarginTop = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSML To temp : tempPPD.MarginLeft = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSMR To temp : tempPPD.MarginRight = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSMB To temp : tempPPD.MarginBottom = Val(temp)

   'Header
   Control Get Check PPG.hSetupDlg, %IDC_PPSShowHeader To tempPPD.ShowHeader
   Control Get Check PPG.hSetupDlg, %IDC_PPSHeaderImage To tempPPD.ShowHeaderImage
   Control Get Check PPG.hSetupDlg, %IDC_PPSHeaderBorder To tempPPD.HeaderImageBorder
   Control Get Check PPG.hSetupDlg, %IDC_PPSGrayScaleH To tempPPD.GrayScaleH
   Control Get Check PPG.hSetupDlg, %IDC_PPSLightenH To tempPPD.LightenH
   Control Get Check PPG.hSetupDlg, %IDC_PPSNaturalH To tempPPD.HeaderNatural

   Control Get Text PPG.hSetupDlg, %IDC_PPSHeaderHeight To temp : tempPPD.HeaderHeight = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSImageNameH To tempPPD.HeaderImageName
   Control Get Text PPG.hSetupDlg, %IDC_PPSHeaderCW To temp : tempPPD.HeaderImageContW = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSHeaderCW To temp : tempPPD.HeaderImageContW = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSHeaderLeft To tempPPD.TopLeftText
   Control Get Text PPG.hSetupDlg, %IDC_PPSHeaderCenter To tempPPD.TopCenterText
   Control Get Text PPG.hSetupDlg, %IDC_PPSHeaderRight To tempPPD.TopRightText

   'Footer
   Control Get Check PPG.hSetupDlg, %IDC_PPSShowFooter To tempPPD.ShowFooter
   Control Get Check PPG.hSetupDlg, %IDC_PPSFooterImage To tempPPD.ShowFooterImage
   Control Get Check PPG.hSetupDlg, %IDC_PPSFooterBorder To tempPPD.FooterImageBorder
   Control Get Check PPG.hSetupDlg, %IDC_PPSGrayScaleF To tempPPD.GrayScaleF
   Control Get Check PPG.hSetupDlg, %IDC_PPSLightenF To tempPPD.LightenF
   Control Get Check PPG.hSetupDlg, %IDC_PPSNaturalF To tempPPD.FooterNatural

   Control Get Text PPG.hSetupDlg, %IDC_PPSFooterHeight To temp : tempPPD.FooterHeight = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSImageNameF To tempPPD.FooterImageName
   Control Get Text PPG.hSetupDlg, %IDC_PPSFooterCW To temp : tempPPD.FooterImageContW = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSFooterCW To temp : tempPPD.FooterImageContW = Val(temp)
   Control Get Text PPG.hSetupDlg, %IDC_PPSFooterLeft To tempPPD.BottomLeftText
   Control Get Text PPG.hSetupDlg, %IDC_PPSFooterCenter To tempPPD.BottomCenterText
   Control Get Text PPG.hSetupDlg, %IDC_PPSFooterRight To tempPPD.BottomRightText

   If PPD.ShowHeader Then tempPPG.HeaderHeight = tempPPD.HeaderHeight  Else tempPPG.HeaderHeight = 0
   If PPD.ShowFooter Then tempPPG.FooterHeight = tempPPD.FooterHeight  Else tempPPG.FooterHeight = 0

'   Control Get Text PPG.hSetupDlg, %IDC_PrintSettingsTextExtensions To PPD.TextExtensions
End Sub

Sub PPPageSetupDialog
   Local Style As Long
   Dialog New Pixels, PPG.hDlg, "Page Setup",100,150,670,460, %WS_SysMenu To PPG.hSetupDlg
   Dialog Set Icon PPG.hSetupDlg, "ppmargins"
   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll _
      Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop Or %WS_Border

   tempPPD = PPD  'lets me easily check if anything changes
   tempPPG = PPG

   Control Add Frame, PPG.hSetupDlg, %IDC_PPSFrameText, "Main Body",   10, 10, 315, 415
   Control Add Frame, PPG.hSetupDlg, %IDC_PPSFrameHeader, "Header",   340, 10, 320, 205
   Control Add Frame, PPG.hSetupDlg, %IDC_PPSFrameFooter, "Footer",   340, 220, 320, 205

   'Main Body
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSOrientation, "Portrait", 20, 35, 90, 20
   Control Add Label, PPG.hSetupDlg, %IDC_PPSTextColor, "", 20, 55, 15,15, %WS_Border Or %SS_Notify
   Control Add Label, PPG.hSetupDlg, %IDC_PPSTextcolorL, "Text Color", 40, 55, 90, 20
   Control Add Label, PPG.hSetupDlg, %IDC_PPSBGColor, "", 20, 75, 15,15, %WS_Border Or %SS_Notify
   Control Add Label, PPG.hSetupDlg, %IDC_PPSBGColorL, "BG Color", 40, 75, 90, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSShowBGImage, "Show BG Image", 20, 95, 90, 20

   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSWordWrap, "Word Wrap", 130, 35, 80, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSAutoClose, "AutoClose", 130, 55, 90, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSLineNumbers, "Line Numbers", 130, 75, 90, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSMarginOutlines, "Margin Outlines", 130, 95, 100, 20

   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSLightenBG, "Lighten", 235, 35, 80, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSGrayScaleBG, "Gray Scale", 235, 55, 90, 20
   Control Add ImgButton, PPG.hSetupDlg, %IDC_PPSFont, "ppfont", 255, 80, 25, 25

   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSCustomFF, "Custom FF:", 20, 125, 90, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSCustomFFText, tempPPD.CustomFFText, 130, 125, 90, 20

   Control Add Label, PPG.hSetupDlg, %IDC_PPSLabelExtensions, "Text File Extensions:", 20, 155, 120, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSExtensions, tempPPD.TextExtensions, 130, 155, 160, 20

   Control Add Button, PPG.hSetupDlg, %IDC_PPSSelectBGImage, "BG Image...", 20, 190, 80, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSBGImageName, tempPPD.BGImageName, 20, 215, 290, 20

   Control Add Button, PPG.hSetupDlg, %IDC_PPSSelectFileName, "File Name...", 20, 250, 80, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSFileName, tempPPD.FileName, 20, 275, 290, 20

   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSMT, Format$(tempPPD.MarginTop,"0.0"),    105, 338, 40, 20 , %ES_Center Or %WS_TabStop Or %WS_Border, %WS_Ex_ClientEdge
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSML, Format$(tempPPD.MarginLeft,"0.0"),    70, 358, 40, 20 , %ES_Center Or %WS_TabStop Or %WS_Border, %WS_Ex_ClientEdge
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSMR, Format$(tempPPD.MarginRight,"0.0"),  140, 358, 40, 20 , %ES_Center Or %WS_TabStop Or %WS_Border, %WS_Ex_ClientEdge
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSMB, Format$(tempPPD.MarginBottom,"0.0"), 105, 380, 40, 20 , %ES_Center Or %WS_TabStop Or %WS_Border, %WS_Ex_ClientEdge

   Control Add Label, PPG.hSetupDlg, %IDC_PPSMarginL, "Margins:",    20,  315, 50,20
   Control Add Label, PPG.hSetupDlg, %IDC_PPSMTL, "Top",    115,  323, 30, 15
   Control Add Label, PPG.hSetupDlg, %IDC_PPSMLL, "Left",   45,   360, 25, 20
   Control Add Label, PPG.hSetupDlg, %IDC_PPSMRL, "Right",  185,  360, 30, 20
   Control Add Label, PPG.hSetupDlg, %IDC_PPSMBL, "Bottom", 110,  398, 35, 17

   Control Add Button, PPG.hSetupDlg, %IDC_PPSSaveAndExit,"Save && Exit", 220,435,70,20
   Control Add Button, PPG.hSetupDlg, %IDC_PPSApply,"Apply", 300,435,70,20
   Control Add Button, PPG.hSetupDlg, %IDC_PPSCancel,"Cancel", 380,435,70,20

   'Header
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSShowHeader, "Show Header", 350, 35, 90, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSHeaderImage, "Image", 380, 60, 50, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSHeaderHeight, Format$(tempPPD.HeaderHeight,"0.0"), 450, 35, 30, 20
   Control Add Label, PPG.hSetupDlg, %IDC_PPSHeaderHeightL, "Height", 485, 40, 50, 20

   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSLightenH, "Lighten", 530, 35, 70, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSHeaderBorder, "Border", 450, 60, 50, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSGrayScaleH, "GrayScale", 530, 60, 70, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSNaturalH, "Natural Size", 530, 85, 90, 20
   Control Add ImgButton, PPG.hSetupDlg, %IDC_PPSFontH, "ppfont", 615, 35, 25, 25

   Control Add Button, PPG.hSetupDlg, %IDC_PPSSelectImageH, "Header Image...", 350, 90, 100, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSImageNameH, tempPPD.HeaderImageName, 350, 115, 295, 20

   Control Add Label, PPG.hSetupDlg, %IDC_PPSContainerHL, "Image Container Size (wxh):", 350, 150, 150, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSHeaderCW, Format$(tempPPD.HeaderImageContW,"0.0"), 510, 150, 40, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSHeaderCH, Format$(tempPPD.HeaderImageContH,"0.0"), 560, 150, 40, 20

   Control Add Label, PPG.hSetupDlg, %IDC_PPSTitlesHL, "Titles:", 350, 180, 40, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSHeaderLeft, tempPPD.TopLeftText, 390,180, 80, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSHeaderCenter, tempPPD.TopCenterText, 480,180, 80, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSHeaderRight, tempPPD.TopRightText, 570,180, 80, 20

   'Footer
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSShowFooter, "Show Footer", 350, 245, 90, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSFooterImage, "Image", 380, 270, 50, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSFooterHeight, Format$(tempPPD.FooterHeight,"0.0"), 450, 245, 30, 20
   Control Add Label, PPG.hSetupDlg, %IDC_PPSFooterHeightL, "Height", 485, 250, 50, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSLightenF, "Lighten", 530, 245, 70, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSFooterBorder, "Border", 450, 270, 50, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSGrayScaleF, "GrayScale", 530, 270, 70, 20
   Control Add CheckBox, PPG.hSetupDlg, %IDC_PPSNaturalF, "Natural Size", 530, 295, 90, 20
   Control Add ImgButton, PPG.hSetupDlg, %IDC_PPSFontH, "ppfont", 615, 245, 25, 25

   Control Add Button, PPG.hSetupDlg, %IDC_PPSSelectImageF, "Footer Image...", 350, 300, 100, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSImageNameF, tempPPD.FooterImageName, 350,325, 295, 20

   Control Add Label, PPG.hSetupDlg, %IDC_PPSContainerFL, "Image Container Size (wxh):", 350, 360, 150, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSFooterCW, Format$(tempPPD.FooterImageContW,"0.0"), 510, 360, 40, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSFooterCH, Format$(tempPPD.FooterImageContH,"0.0"), 560, 360, 40, 20

   Control Add Label, PPG.hSetupDlg, %IDC_PPSTitlesFL, "Titles:", 350, 390, 40, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSFooterLeft, tempPPD.BottomLeftText, 390,390, 80, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSFooterCenter, tempPPD.BottomCenterText, 480,390, 80, 20
   Control Add TextBox, PPG.hSetupDlg, %IDC_PPSFooterRight, tempPPD.BottomRightText, 570,390, 80, 20

   Dialog Show Modal PPG.hSetupDlg Call PPSetupDialogProc
   PPSetMenusAndToolbarButtons
End Sub

CallBack Function PPSetupDialogProc() As Long
   Local i As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         'subclass
         For i = %IDC_PPSCustomFFText To %IDC_PPSFooterRight
            PPG.OldProc = SetWindowLong(GetDlgItem(PPG.hSetupDlg, i), %GWL_WndProc, CodePtr(PPNewTextProc))  'subclass
         Next i
         'fonts
         For i = %IDC_PPSCustomFFText To %IDC_PPSCancel
            Control Set Font PPG.hSetupDlg, i, PPG.hControlFont
         Next i
         'frame fonts
         Control Set Font PPG.hSetupDlg, %IDC_PPSFrameText, PPG.hControlFontB
         Control Set Font PPG.hSetupDlg, %IDC_PPSFrameHeader, PPG.hControlFontB
         Control Set Font PPG.hSetupDlg, %IDC_PPSFrameFooter, PPG.hControlFontB

         'Set checks on Main Body
         Control Set Check PPG.hSetupDlg, %IDC_PPSOrientation, tempPPD.Orientation
         Control Set Check PPG.hSetupDlg, %IDC_PPSShowBGImage, tempPPD.ShowBGImage
         Control Set Check PPG.hSetupDlg, %IDC_PPSGrayScaleBG, tempPPD.GrayScaleBG
         Control Set Check PPG.hSetupDlg, %IDC_PPSAutoClose, tempPPD.AutoClose
         Control Set Check PPG.hSetupDlg, %IDC_PPSLineNumbers, tempPPD.LineNumbers
         Control Set Check PPG.hSetupDlg, %IDC_PPSMarginOutlines, tempPPD.ShowMargins
         Control Set Check PPG.hSetupDlg, %IDC_PPSCustomFF, tempPPD.CustomFF
         Control Set Check PPG.hSetupDlg, %IDC_PPSLightenBG, tempPPD.LightenBG
         Control Set Check PPG.hSetupDlg, %IDC_PPSWordWrap, tempPPD.WordWrap

         Control Set Color PPG.hSetupDlg, %IDC_PPSTextColor, %Black, tempPPD.TextColor
         Control Set Color PPG.hSetupDlg, %IDC_PPSBGColor, %Black, tempPPD.BGColor

         'Set Checks on Header
         Control Set Check PPG.hSetupDlg, %IDC_PPSShowHeader, tempPPD.ShowHeader
         Control Set Check PPG.hSetupDlg, %IDC_PPSHeaderImage, tempPPD.ShowHeaderImage
         Control Set Check PPG.hSetupDlg, %IDC_PPSHeaderBorder, tempPPD.HeaderImageBorder
         Control Set Check PPG.hSetupDlg, %IDC_PPSGrayScaleH, tempPPD.GrayScaleH
         Control Set Check PPG.hSetupDlg, %IDC_PPSLightenH, tempPPD.LightenH
         Control Set Check PPG.hSetupDlg, %IDC_PPSNaturalH, tempPPD.HeaderNatural

         'Set Checks on Footer
         Control Set Check PPG.hSetupDlg, %IDC_PPSShowFooter, tempPPD.ShowFooter
         Control Set Check PPG.hSetupDlg, %IDC_PPSFooterImage, tempPPD.ShowFooterImage
         Control Set Check PPG.hSetupDlg, %IDC_PPSFooterBorder, tempPPD.FooterImageBorder
         Control Set Check PPG.hSetupDlg, %IDC_PPSGrayScaleF, tempPPD.GrayScaleF
         Control Set Check PPG.hSetupDlg, %IDC_PPSLightenF, tempPPD.LightenF
         Control Set Check PPG.hSetupDlg, %IDC_PPSNaturalF, tempPPD.FooterNatural

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_PPSTextColor
               tempPPD.TextColor = PPSelectColor(tempPPD.TextColor)
               Control Set Color PPG.hSetupDlg, %IDC_PPSTextColor, %Black, tempPPD.TextColor
            Case %IDC_PPSBGColor
               tempPPD.BGColor   = PPSelectColor(tempPPD.BGColor)
               Control Set Color PPG.hSetupDlg, %IDC_PPSBGColor, %Black, tempPPD.BGColor

            Case %IDC_PPSFont  : PPSelectTextFont
            Case %IDC_PPSFontH : PPSelectHeaderFont
            Case %IDC_PPSFontF : PPSelectFooterFont

            Case %IDC_PPSSelectFileName
               tempPPD.FileName = PPSelectFile
               Control Set Text PPG.hSetupDlg, %IDC_PPSFileName, tempPPD.FileName

            Case %IDC_PPSSelectBGImage
               PPSelectImage tempPPD.BGImageName, "Select Background Image"
               Control Set Text PPG.hSetupDlg, %IDC_PPSBGImageName, tempPPD.BGImageName

            Case %IDC_PPSSelectImageH
               PPSelectImage tempPPD.HeaderImageName, "Select Header Image"
               Control Set Text PPG.hSetupDlg, %IDC_PPSImageNameH, tempPPD.HeaderImageName

            Case %IDC_PPSSelectImageF
               PPSelectImage tempPPD.HeaderImageName, "Select Footer Image"
               Control Set Text PPG.hSetupDlg, %IDC_PPSImageNameF, tempPPD.FooterImageName

            Case %IDC_PPSSaveAndExit, %IDC_PPSApply
               'get Settings dialog values
               PPPrintGetTempPPD
               'if filename has changed, read the text
               If IsFile(tempPPD.FileName) And (tempPPD.FileName <> PPD.FileName) Then
                  'get new text file
                  Open tempPPD.FileName For Binary As #1
                  Get$ #1, Lof(1), PPGlobalText
                  Close #1
               End If
               'transfer tempPPD values to PPD
               PPD = tempPPD
               'in case of font changes
               PPBuildFonts
               PPBuildFontsSF
               'rebuild images (new names/gray/lighten/...
               Graphic Attach PPG.hImageHeader,0     : Graphic Bitmap End
               Graphic Attach PPG.hImageFooter,0     : Graphic Bitmap End
               Graphic Attach PPG.hImageBackground,0 : Graphic Bitmap End
               PPLoadImagesToMemoryBitmaps
               'printer settings
               If PPD.Orientation Then XPrint Set Orientation 1 Else XPrint Set Orientation 2
               PPSetPrinterProperties
               'set toolbar and menus
               PPSetMenusAndtoolbarButtons
               'display text with the next settings
               PPPrintToGraphic
               If Cb.Ctl = %IDC_PPSSaveAndExit Then Dialog End PPG.hSetupDlg
            Case %IDC_PPSCancel : Dialog End PPG.hSetupDlg
         End Select
      Case %WM_SysCommand
         PPPrintGetTempPPD
         If tempPPD <> PPD Then
            Select Case MsgBox("Changes not saved. Save changes?!", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "Exit Setup Dialog")
               Case %IdYes    : PPD = tempPPD : PPPrintToGraphic : PPSetMenusAndToolbarButtons
               Case %IdNo     'no action - go ahead with closing
               Case %IdCancel : Function = 1
            End Select
         End If
      Case %WM_Destroy
   End Select
End Function

Function PPBuildFakeImage(w As Long, h As Long) As Dword
   Local hFake As Dword
   Graphic Bitmap New w,h To hFake
   Graphic Attach hFake, 0
   Graphic Color %Black, %rgb_Orange
   Graphic Clear
   Graphic Width 5
   Graphic Line (0,0)-(w-1,h-1)
   Graphic Line (w-1,0)-(0,h-1)
   Function = hFake
End Function

Sub PPLoadImagesToMemoryBitmaps
   Local pGraphics,pImage,hDC,token As Dword, StartupInput As GdiplusStartupInput
   'initialize GDI
   StartupInput.GdiplusVersion = 1                    'initialize GDIPlus
   GdiplusStartup(token, StartupInput, ByVal %NULL)   'initialize GDIPlus

   'background
   If IsFile(PPD.BGImageName) Then
      GdipLoadImageFromFile((PPD.BGImageName), pImage)     'load image
      GdipGetImageWidth(pImage,PPG.BGImageW)           'get width
      GdipGetImageHeight(pImage, PPG.BGImageH)         'get height

      Graphic Bitmap New PPG.BGImageW,PPG.BGImageH To PPG.hImageBackGround
      Graphic Attach PPG.hImageBackground, 0
      Graphic Get DC To hDC

      GdipCreateFromHDC(hDC, pGraphics)                  ' Create the Graphic object
      GdipDrawImage(pGraphics, pImage, 0, 0)             ' Draw the image
      If pImage Then GdipDisposeImage(pImage)            'cleanup
      If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
   Else
      PPG.BGImageW = 100
      PPG.BGImageH = 100
      PPG.hImageBackground = PPBuildFakeImage(PPG.BGImageW,PPG.BGImageH)
   End If

   'footer
   If IsFile(PPD.FooterImageName) Then
      GdipLoadImageFromFile((PPD.FooterImageName), pImage)     'load image
      GdipGetImageWidth(pImage,PPG.FooterImageW)           'get width
      GdipGetImageHeight(pImage, PPG.FooterImageH)         'get height

      Graphic Bitmap New PPG.FooterImageW,PPG.FooterImageH To PPG.hImageFooter
      Graphic Attach PPG.hImageFooter, 0
      Graphic Get DC To hDC

      GdipCreateFromHDC(hDC, pGraphics)                  ' Create the Graphic object
      GdipDrawImage(pGraphics, pImage, 0, 0)             ' Draw the image
      If pImage Then GdipDisposeImage(pImage)            'cleanup
      If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
   Else
      PPG.FooterImageW = 100
      PPG.FooterImageH = 100
      PPG.hImageFooter = PPBuildFakeImage(PPG.FooterImageW,PPG.FooterImageH)
   End If

   'header
   If IsFile(PPD.HeaderImageName) Then
      GdipLoadImageFromFile((PPD.HeaderImageName), pImage)     'load image
      GdipGetImageWidth(pImage,PPG.HeaderImageW)           'get width
      GdipGetImageHeight(pImage, PPG.HeaderImageH)         'get height

      Graphic Bitmap New PPG.HeaderImageW,PPG.HeaderImageH To PPG.hImageHeader
      Graphic Attach PPG.hImageHeader, 0
      Graphic Get DC To hDC

      GdipCreateFromHDC(hDC, pGraphics)                  ' Create the Graphic object
      GdipDrawImage(pGraphics, pImage, 0, 0)             ' Draw the image
      If pImage Then GdipDisposeImage(pImage)            'cleanup
      If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
      GdiplusShutdown token                              'shutdown GDI+
   Else
      PPG.HeaderImageW = 100
      PPG.HeaderImageH = 100
      PPG.hImageHeader = PPBuildFakeImage(PPG.HeaderImageW,PPG.HeaderImageH)
   End If

   If (PPD.GrayScaleH Or PPD.LightenH) Then PPConvertImage(PPG.hImageHeader,PPD.LightenH,PPD.GrayScaleH)       ' apply gray scale to currently attached image
   If (PPD.GrayScaleF Or PPD.LightenF) Then PPConvertImage(PPG.hImageFooter,PPD.LightenF,PPD.GrayScaleF)       ' apply gray scale to currently attached image
   If (PPD.GrayScaleBG Or PPD.LightenBG) Then PPConvertImage(PPG.hImageBackground,PPD.LightenBG,PPD.GrayScaleBG)  ' apply gray scale to currently attached image
End Sub

Sub PPConvertImage(hBMP As Dword, Lighten As Long, GrayScale As Long)   'works on currently attached Graphic target
   Local i,w,h As Long, p As Long Ptr, bmp$, iColor As Dword
   Local R,G,B,correctionfactor As Single
   'correction factor
   correctionfactor = 0.6
   'get the string from ID_Graphic1
   Graphic Attach hBMP, 0
   Graphic Get Bits To bmp$
   'get width/height of image
   w = Cvl(bmp$,1)
   h = Cvl(bmp$,5)
   p = StrPtr(bmp$)+8    'position of starting position for bits in string
   'get string position of coordinates and modify the string at that position
   For i = 1 To w*h
      'get RGB component values
      iColor = @p                           'result is a BGR color value 0-R-G-B
      B = iColor Mod 256                    'or this: iColor AND &HFF&
      G = (iColor\256) Mod 256              'or this: (iColor AND &HFF00&) \ &H100
      R = (iColor\256\256) Mod 256          'or this: (iColor AND &HFF0000&) \ &H10000&

      If Lighten Then
         R = (255-R) * CorrectionFactor + R
         G = (255-G) * CorrectionFactor + G
         B = (255-B) * CorrectionFactor + B
         @p = Bgr(R,G,B)           'modify string at that position
      End If

      If GrayScale Then
         iColor = 0.299*R + 0.587*G + 0.114*B  'or this: iColor = (R+G+B)/3
         @p = Bgr(iColor, iColor, iColor)           'modify string at that position
      End If

      Incr p
   Next i
   'put the modified string back into selected Graphic target
   Graphic Set Bits bmp$
End Sub

Sub PPBuildFonts
   Local hTemp As Dword

   hTemp = PPG.hFontText
   Font New PPD.FontName, PPD.FontPoints, PPD.FontStyle To PPG.hFontText
   Font End hTemp

   hTemp = PPG.hFontHeader
   Font New PPD.FontNameH, PPD.FontPointsH, PPD.FontStyleH To PPG.hFontHeader
   Font End hTemp

   hTemp = PPG.hFontFooter
   Font New PPD.FontNameF, PPD.FontPointsF, PPD.FontStyleF To PPG.hFontFooter
   Font End hTemp
End Sub

Sub PPResizeWindow
   Local w,h As Long
   Dialog Get Client PPG.hDlg To w,h
   Control Set Size PPG.hDlg, %IDC_PPGraphic, w,h - %PPToolbar_Height
End Sub

Sub PPBuildFontsSF
   Local hTemp As Dword, SF As Single, wCont,hCont,wPreview,hPreview As Long

   'calculate SF (need PPG.PreViewW to calculate SF)
   Dialog Get Client PPG.hDlg To wCont, hCont : hCont -= %PPToolbar_Height
   wPreview = PPG.ScreenPPIx * PPD.PaperSizeW   'original width in pixels
   hPreview = PPG.ScreenPPIy * PPD.PaperSizeH   'original height in pixels
   Select Case PPD.ZoomFactor
      Case 1  'display whole page sized to fit within the dialog
         PPG.PreviewW = wPreview / Max(wPreview/wCont, hPreview/hCont) * 0.9
      Case 2  'display page size to fit width of dialog
         PPG.PreviewW = wPreview / Max(wPreview/wCont, hPreview/hCont) * 0.9
      Case 3  'display page size to fit width of dialog
         PPG.PreviewW = wCont * 0.9
      Case Else    'display page at UL postion of 20,20  '3-.25 4-.50 5-.75 6-1.0 7-2.0 8-4.0
         PPG.PreviewW = wPreview * Val(Parse$(PPG.ZoomText, $Spc, PPD.ZoomFactor))/100
   End Select
   SF = PPG.PreviewW / (PPD.PaperSizeW * PPG.ScreenPPIx)
   'build SF fonts
   hTemp = PPG.hFontTextSF
   PPD.FontPointsSF = PPD.FontPoints * SF
   Font New PPD.FontName, PPD.FontPointsSF, PPD.FontStyle To PPG.hFontTextSF
   Font End hTemp

   hTemp = PPG.hFontHeaderSF
   PPD.FontPointsHSF = PPD.FontPointsH * SF
   Font New PPD.FontNameH, PPD.FontPointsHSF, PPD.FontStyleH To PPG.hFontHeaderSF
   Font End hTemp

   hTemp = PPG.hFontFooterSF
   PPD.FontPointsFSF = PPD.FontPointsF * SF
   Font New PPD.FontNameF, PPD.FontPointsFSF, PPD.FontStyleF To PPG.hFontFooterSF
   Font End hTemp
End Sub
